/**
 * \file
 *
 * \brief x~Ǘ
 *
 * 쌠 (c) 2010 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SLEEPMGR_H
#define SLEEPMGR_H

#include <compiler.h>
#include <parts.h>

#if (SAM3S || SAM3U || SAM3N || SAM3XA || SAM4S || SAM4E)
# include "sam/sleepmgr.h"
#elif XMEGA
# include "xmega/sleepmgr.h"
#elif UC3
# include "uc3/sleepmgr.h"
#elif SAM4L
# include "sam4l/sleepmgr.h"
#else
# error Unsupported device.
#endif

/**
 * \defgroup sleepmgr_group x~Ǘ
 *
 * x~Ǘ޲(Ⴆ΁AӋ@\ײށA޽Ap)[x~
 * ł̋x~ɉ悤ɂȂƂۏ؂邽߂̻޽łB
 *
 * ͌ʋx~p̌Œv̎gpɊÂA0łȂŒvł
 * x~޲x~ɂ܂Bײ/޽/p\ref sleepmgr_lock_mode
 *   \ref sleepmgr_unlock_mode ̎gpɂĂ̌vύX邱Ƃł
 * ܂BŒɑ΂ėp\ȋx~̈ꗗɂĂ \ref sleepmgr_mode A
 * ̌ʂɂĂްĂQƂĂB
 *
 * p \ref conf_sleepmgr.h ̧قȂ΂Ȃ܂B
 *
 * ׂx~Ǘɑ΂āA \ref CONFIG_SLEEPMGR_ENABLE قAႦ
 * ΁A \ref conf_sleepmgr.h Œ`Ȃ΂Ȃ܂B̼ق`
 * ȂꍇÅ֐͋U֐ŒuRAM͑Sgp܂B
 *
 * @{
 */

/**
 * \def CONFIG_SLEEPMGR_ENABLE
 * \brief x~Ǘp`Ԑݒ
 *
 * ̼ق`ȂꍇA̻޽̊֐͋U֐Œu܂B
 * ͉pŋx~ǗKvƂȂꍇɺޗʂƎsԂ炷̂ɗLp
 * B
 *
 * ̼ق \ref conf_sleepmgr.h Œ`邩܂B
 */
#if defined(__DOXYGEN__) && !defined(CONFIG_SLEEPMGR_ENABLE)
#  define CONFIG_SLEEPMGR_ENABLE
#endif

/**
 * \enum sleepmgr_mode
 * \brief x~Œ
 *
 * ex~Œ莯ʎq
 */

/**
 * \brief Œv평
 *
 * 1ɐݒ肳Ō̂̂đSĂ̌Œv0ɐݒ肵܂B
 * \ref sleepmgr_enter_sleep ŋe\ȍł[x~邽߂̒P
 * Z@̂߂ɍs܂B
 */
static inline void sleepmgr_init(void)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	uint8_t i;

	for (i = 0; i < SLEEPMGR_NR_OF_MODES - 1; i++) {
		sleepmgr_locks[i] = 0;
	}
	sleepmgr_locks[SLEEPMGR_NR_OF_MODES - 1] = 1;
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

/**
 * \brief x~ɑ΂Œv𑝉
 *
 * x~Ǘ[x~޲x~ɒuȂƂۏ؂邽߂ 
 * \a mode ɑ΂Œv𑝉܂B
 *
 * \param mode Œ肷邽߂̋x~
 */
static inline void sleepmgr_lock_mode(enum sleepmgr_mode mode)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	irqflags_t flags;

	Assert(sleepmgr_locks[mode] < 0xff);

	// dv̈ɓ
	flags = cpu_irq_save();

	++sleepmgr_locks[mode];

	// dv̈𔲂
	cpu_irq_restore(flags);
#else
	UNUSED(mode);
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

/**
 * \brief x~ɑ΂ČŒv
 *
 * \a mode ɑ΂Œv܂BŒv0ɒBꍇAx~Ǘ
 * [x~޲x~ɂ܂B
 *
 * \param mode Œx~
 */
static inline void sleepmgr_unlock_mode(enum sleepmgr_mode mode)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	irqflags_t flags;

	Assert(sleepmgr_locks[mode]);

	// dv̈֓
	flags = cpu_irq_save();

	--sleepmgr_locks[mode];

	// dv̈𔲂
	cpu_irq_restore(flags);
#else
	UNUSED(mode);
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

 /**
 * \brief e\ȍł[x~擾
 *
 * ł󂢋x~삩n߂čŏ0łȂŒv܂ŋx~Œv
 * ʂČ܂Be\ȍł[x~삪̌ɕԂ܂B
 */
static inline enum sleepmgr_mode sleepmgr_get_sleep_mode(void)
{
	enum sleepmgr_mode sleep_mode = SLEEPMGR_ACTIVE;

#ifdef CONFIG_SLEEPMGR_ENABLE
	uint8_t *lock_ptr = sleepmgr_locks;

	// ł󂢓ŏ߂āAŏ0łȂŒv܂B
	while (!(*lock_ptr)) {
		lock_ptr++;
		sleep_mode++;
	}

	// ł[x~1]sleepmgr_unlock_mode()Ăяos
	// ߂炦B
	Assert((uintptr_t)(lock_ptr - sleepmgr_locks) < SLEEPMGR_NR_OF_MODES);

#endif /* CONFIG_SLEEPMGR_ENABLE */

	return sleep_mode;
}

/**
 * \fn sleepmgr_enter_sleep
 * \brief e\ȍł[ŋx~֍s
 *
 * ł󂢋x~Ŏn߂čŏ0łȂŒv܂ŋx~v
 * Č܂B̌޲͌ŒɑΉx~ŋx~ɂ܂B
 *
 * \note ̊֐͋x~֍sOɊ荞݂AAłꂽ܂
 * ɂ܂B͊ɂ邽߂ɋx~΂ꍇɂKp
 * ܂B
 */

static inline void sleepmgr_enter_sleep(void)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	enum sleepmgr_mode sleep_mode;

	cpu_irq_disable();

	// e\ȍł[x~T܂B
	sleep_mode = sleepmgr_get_sleep_mode();
	// ŏ̓((ACTIVE))ɌŒ肳ꍇAɕA
	if (sleep_mode==SLEEPMGR_ACTIVE) {
		cpu_irq_enable();
		return;
	}
	// ꂽ荞݂Ƌɋe\ȍł[x~ֈڍs
	sleepmgr_sleep(sleep_mode);
#else
	cpu_irq_enable();
#endif /* CONFIG_SLEEPMGR_ENABLE */
}


//! @}

#endif /* SLEEPMGR_H */
