/**
 * \file
 *
 * \brief AVR XMEGA XCL(XMEGA_H)TC(/)⏕Pʕײ
 *
 *
 * 쌠 (C) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _XCL_TIMER_H_
#define _XCL_TIMER_H_

#include "compiler.h"
#include "parts.h"
#include "pmic.h"
#include "conf_xcl.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup xcl_group
 * \defgroup xcl_tc_group XMEGA_H(XCL)/(TC)⏕Pʕ
 *
 * ̌Q/(TC)⏕Pʕ`Ԑݒ肷邽߂̊֐񋟂܂B
 *
 * @{
 */

#if defined(CONFIG_XCL_CALLBACK_ENABLE) || defined(__DOXYGEN__)
typedef void (*xcl_callback_t)(void);
void xcl_set_unf_interrupt_callback(xcl_callback_t callback);
void xcl_set_cc_interrupt_callback(xcl_callback_t callback);
#endif

/* ! XCLTC`Ԑݒ\ */
struct xcl_tc_config_t {
	uint8_t ctrle;
	uint8_t ctrlf;
};

/* ! XCL荞 */
enum xcl_int_level_t {
	XCL_INT_LVL_OFF = 0x00,
	XCL_INT_LVL_LO  = 0x01,
	XCL_INT_LVL_MED = 0x02,
	XCL_INT_LVL_HI  = 0x03,
};

/* ! XCLv``Ԑݒ */
enum xcl_tc_sel_t {

	TC16		= XCL_TCSEL_TC16_gc,		/* !< 16ޯ / */
	BTC0		= XCL_TCSEL_BTC0_gc,		/* !< ()18ޯ / */
	BTC01		= XCL_TCSEL_BTC01_gc,		/* !< 28ޯ / */
	BTC0PEC1	= XCL_TCSEL_BTC0PEC1_gc,	/* !< ()18ޯđMӋ@\v18ޯ / */
	PEC0BTC1	= XCL_TCSEL_PEC0BTC1_gc,	/* !< ()18ޯĎMӋ@\v18ޯ / */
	PEC01		= XCL_TCSEL_PEC01_gc,		/* !< 28ޯĎӋ@\v */
	BTC0PEC2	= XCL_TCSEL_BTC0PEC2_gc,	/* !< ()24ޯđM/MӋ@\v18ޯ / */
};

/* ! XCLvۯ`Ԑݒ */
enum xcl_tc_clk_source_t {
	OFF		= XCL_CLKSEL_OFF_gc,			/* !< OFF */
	DIV1	= XCL_CLKSEL_DIV1_gc,			/* !< Clkper */
	DIV2	= XCL_CLKSEL_DIV2_gc,			/* !< clk/2Ou */
	DIV4	= XCL_CLKSEL_DIV4_gc,			/* !< clk/4Ou */
	DIV8	= XCL_CLKSEL_DIV8_gc,			/* !< clk/8Ou */
	DIV64	= XCL_CLKSEL_DIV64_gc,			/* !< clk/64Ou */
	DIV256	= XCL_CLKSEL_DIV256_gc,			/* !< clk/256Ou */
	DIV1024	= XCL_CLKSEL_DIV1024_gc,		/* !< clk/1024Ou */
	EVCH0	= XCL_CLKSEL_EVCH0_gc,			/* !< 0 */
	EVCH1	= XCL_CLKSEL_EVCH1_gc,			/* !< 1 */
	EVCH2	= XCL_CLKSEL_EVCH2_gc,			/* !< 2 */
	EVCH3	= XCL_CLKSEL_EVCH3_gc,			/* !< 3 */
	EVCH4	= XCL_CLKSEL_EVCH4_gc,			/* !< 4 */
	EVCH5	= XCL_CLKSEL_EVCH5_gc,			/* !< 5 */
	EVCH6	= XCL_CLKSEL_EVCH6_gc,			/* !< 6 */
	EVCH7	= XCL_CLKSEL_EVCH7_gc,			/* !< 7 */
};

/* ! XCLv퓮`Ԑݒ */
enum xcl_tc_mode_t {
	NORMAL = XCL_TCMODE_NORMAL_gc,			/* !< ()W */
	CAPT = XCL_TCMODE_CAPT_gc,				/* !< ߊl */
	PWM = XCL_TCMODE_PWM_gc,				/* !< PXPWM */
};

/* ! (܂͒PvĎn邽߂)XCLvwߌ` */
enum xcl_tc_cmd_restart_type {
	NO_CMD			= XCL_CMDEN_DISABLE_gc,	/* !< wߖ */
	RESTART_TIMER0	= XCL_CMDEN_CMD0_gc,	/* !< /0ɑ΂ĎwߗL */
	RESTART_TIMER1	= XCL_CMDEN_CMD1_gc,	/* !< /1ɑ΂ĎwߗL */
	RESTART_TIMER01	= XCL_CMDEN_CMD01_gc,	/* !< /01̗ɑ΂ĎwߗL */
};

/**
 * \brief IXCLvōĎnw߂𐶐
 *
 * ̊֐ҰƂēnꂽXCLvɑ΂čĎnw߂n߂܂
 *
 * \param  restart_type Ďn^w
 */
static inline void xcl_tc_restart(enum xcl_tc_cmd_restart_type restart_type)
{
	XCL.CTRLF &= ~XCL_CMDEN_gm;
	XCL.CTRLF |= restart_type;
	XCL.CTRLE |= XCL_CMDSEL_bm;
}

/**
 * \brief XCLvPʕۯ`Ԑݒ
 *
 * ̊֐ҰƂēnI񂾋ۯɏ]XCLv틟ۯ
 * `Ԑݒ肵܂B
 *
 * \param  src I񂾋ۯ
 */
static inline void xcl_tc_source_clock(enum xcl_tc_clk_source_t src)
{
	XCL.CTRLE &= ~XCL_CLKSEL_gm;
	XCL.CTRLE |= src;
}

/**
 * \brief XCLvPʕ``Ԑݒ
 *
 * ̊֐ҰƂēnI񂾓ɏ]XCLv퓮`Ԑݒ肵
 * B
 *
 * \param  tc_sel vI
 */
static inline void xcl_tc_type(enum xcl_tc_sel_t tc_sel)
{
	XCL.CTRLE &= ~XCL_TCSEL_gm;
	XCL.CTRLE |= tc_sel;
}

/**
 * \brief XCLvr0o(CC0)
 *
 * ̊֐XCLBTC0v̔r0o͂܂B
 *
 */
static inline void xcl_enable_oc0(void)
{
	XCL.CTRLF |= XCL_CCEN0_bm;
}

/**
 * \brief XCLvr0o(CC0)֎~
 *
 * ̊֐XCLBTC0v̔r0o͂֎~܂B
 *
 */
static inline void xcl_disable_oc0(void)
{
	XCL.CTRLF &= ~XCL_CCEN0_bm;
}

/**
 * \brief XCLvr1o(CC1)
 *
 * ̊֐XCLBTC1v̔r1o͂܂B
 *
 */
static inline void xcl_enable_oc1(void)
{
	XCL.CTRLF |= XCL_CCEN1_bm;
}

/**
 * \brief XCLvr1o(CC1)֎~ 
 *
 * ̊֐XCLBTC1v̔r1o͂֎~܂B
 *
 */
static inline void xcl_disable_oc1(void)
{
	XCL.CTRLF &= ~XCL_CCEN1_bm;
}

/**
 * \brief XCLvr0o(CC0) 
 *
 * ̊֐XCLvr0o݂w肳ꂽ_قɋ܂B
 *
 * \note XCLv͔ro݂邽߂OFFɐ؂ւׂłB
 *
 * \param  value CC0݂ŋ_l
 */
static inline void xcl_force_oc0(bool value)
{
	if (value) {
		XCL.CTRLF |= XCL_CMP0_bm;
	} else {
		XCL.CTRLF &= ~XCL_CMP0_bm;
	}
}

/**
 * \brief XCLvr1o(CC1) 
 *
 * ̊֐XCLvr1o݂w肳ꂽ_قɋ܂B
 *
 * \note XCLv͔ro݂邽߂OFFɐ؂ւׂłB
 *
 * \param  value CC1݂ŋ_l
 */
static inline void xcl_force_oc1(bool value)
{
	if (value) {
		XCL.CTRLF |= XCL_CMP1_bm;
	} else {
		XCL.CTRLF &= ~XCL_CMP1_bm;
	}
}

/**
 * \brief XCLv퓮`Ԑݒ
 *
 * ̊֐ҰƂēnI񂾓ɏ]XCLv퓮`Ԑݒ肵
 * B
 *
 * \param  mode vI
 */
static inline void xcl_tc_mode(enum xcl_tc_mode_t mode)
{
	XCL.CTRLF &= ~XCL_MODE_gm;
	XCL.CTRLF |= mode;
}

/**
 * \ingroup xcl_tc_group
 * \defgroup xcl_tc_it XMEGA_H(XCL)T/C荞݊Ǘ
 * ̌QXCL TC荞݂̋/֎~Ɗ荞׸މǗ邽߂̊֐
 * ܂B
 *
 * @{
 */

/**
 * \brief XCLv퉺ꊄ荞ٌ`Ԑݒ
 *
 * ̊֐ҰƂēnقɏ]XCLv퉺ꊄ荞ق`
 * ݒ肵܂B
 *
 * \param  level 荞
 */
static inline void xcl_tc_set_underflow_interrupt_level(
		enum xcl_int_level_t level)
{
	XCL.INTCTRL &= ~XCL_UNFINTLVL_gm;
	XCL.INTCTRL |= level << XCL_UNFINTLVL_gp;
}

/**
 * \brief XCLvr/ߊl荞ٌ`Ԑݒ
 *
 * ̊֐ҰƂēnقɏ]XCLvr/ߊl荞ق`
 * Ԑݒ肵܂B
 *
 * \param  level 荞
 */
static inline void xcl_tc_set_compare_capture_interrupt_level(
		enum xcl_int_level_t level)
{
	XCL.INTCTRL &= ~XCL_CCINTLVL_gm;
	XCL.INTCTRL |= level << XCL_CCINTLVL_gp;
}

/**
 * \brief XCL TC16v퉺ꊄ荞݂
 *
 * ̊֐XCL TC16ꊄ荞݂܂B
 *
 */
static inline void xcl_tc16_enable_underflow_interrupt(void)
{
	XCL.INTCTRL |= XCL_UNF0IE_bm;
}

/**
 * \brief XCL TC16v퉺ꊄ荞݂֎~
 *
 * ̊֐XCL TC16ꊄ荞݂֎~܂B
 *
 */
static inline void xcl_tc16_disable_underflow_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_UNF0IE_bm;
}

/**
 * \brief XCL BTC0v퉺ꊄ荞݂
 *
 * ̊֐XCL BTC0ꊄ荞݂܂B
 *
 */
static inline void xcl_btc0_enable_underflow_interrupt(void)
{
	XCL.INTCTRL |= XCL_UNF0IE_bm;
}

/**
 * \brief XCL BTC0v퉺ꊄ荞݂֎~
 *
 * ̊֐XCL BTC0ꊄ荞݂֎~܂B
 *
 */
static inline void xcl_btc0_disable_underflow_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_UNF0IE_bm;
}

/**
 * \brief XCL BTC1v퉺ꊄ荞݂
 *
 * ̊֐XCL BTC1ꊄ荞݂܂B
 *
 */
static inline void xcl_btc1_enable_underflow_interrupt(void)
{
	XCL.INTCTRL |= XCL_UNF1IE_bm;
}

/**
 * \brief XCL BTC1v퉺ꊄ荞݂֎~
 *
 * ̊֐XCL BTC1ꊄ荞݂֎~܂B
 *
 */
static inline void xcl_btc1_disable_underflow_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_UNF1IE_bm;
}

/**
 * \brief XCL PEC0v퉺ꊄ荞݂
 *
 * ̊֐XCL PEC0ꊄ荞݂܂B
 *
 */
static inline void xcl_pec0_enable_interrupt(void)
{
	XCL.INTCTRL |= XCL_PEC0IE_bm;
}

/**
 * \brief XCL PEC0v퉺ꊄ荞݂֎~
 *
 * ̊֐XCL PEC0ꊄ荞݂֎~܂B
 *
 */
static inline void xcl_pec0_disable_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_PEC0IE_bm;
}

/**
 * \brief XCL PEC1v퉺ꊄ荞݂
 *
 * ̊֐XCL PEC1ꊄ荞݂܂B
 *
 */
static inline void xcl_pec1_enable_interrupt(void)
{
	XCL.INTCTRL |= XCL_PEC1IE_bm;
}

/**
 * \brief XCL PEC1v퉺ꊄ荞݂֎~
 *
 * ̊֐XCL PEC1ꊄ荞݂֎~܂B
 *
 */
static inline void xcl_pec1_disable_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_PEC1IE_bm;
}

/**
 * \brief XCL TC16vr/ߊl荞݂
 *
 * ̊֐XCL TC16r/ߊl荞݂܂B
 *
 */
static inline void xcl_tc16_enable_cc_interrupt(void)
{
	XCL.INTCTRL |= XCL_CC0IE_bm;
}

/**
 * \brief XCL TC16vr/ߊl荞݂֎~
 *
 * ̊֐XCL TC16r/ߊl荞݂֎~܂B
 *
 */
static inline void xcl_tc16_disable_cc_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_CC0IE_bm;
}

/**
 * \brief XCL BTC1vr/ߊl荞݂
 *
 * ̊֐XCL BTC1r/ߊl荞݂܂B
 *
 */
static inline void xcl_btc1_enable_cc_interrupt(void)
{
	XCL.INTCTRL |= XCL_CC1IE_bm;
}

/**
 * \brief XCL BTC1vr/ߊl荞݂֎~
 *
 * ̊֐XCL BTC1r/ߊl荞݂֎~܂B
 *
 */
static inline void xcl_btc1_disable_cc_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_CC1IE_bm;
}

/**
 * \brief XCL BTC0vr/ߊl荞݂
 *
 * ̊֐XCL BTC0r/ߊl荞݂܂B
 *
 */
static inline void xcl_btc0_enable_cc_interrupt(void)
{
	XCL.INTCTRL |= XCL_CC0IE_bm;
}

/**
 * \brief XCL BTC0vr/ߊl荞݂֎~
 *
 * ̊֐XCL BTC0r/ߊl荞݂֎~܂B
 *
 */
static inline void xcl_btc0_disable_cc_interrupt(void)
{
	XCL.INTCTRL &= ~XCL_CC0IE_bm;
}

/**
 * \brief XCL TC16v퉺ꊄ荞ݗv׸ނ
 *
 * ̊֐XCL TC16ꊄ荞ݗv׸ނ܂B
 *
 */
static inline void xcl_tc16_clear_underflow_interrupt(void)
{
	XCL.INTFLAGS |= XCL_UNF0IF_bm;
}

/**
 * \brief XCL BTC0v퉺ꊄ荞ݗv׸ނ
 *
 * ̊֐XCL BTC0ꊄ荞ݗv׸ނ܂B
 *
 */
static inline void xcl_btc0_clear_underflow_interrupt(void)
{
	XCL.INTFLAGS |= XCL_UNF0IF_bm;
}

/**
 * \brief XCL BTC1v퉺ꊄ荞ݗv׸ނ
 *
 * ̊֐XCL BTC1ꊄ荞ݗv׸ނ܂B
 *
 */
static inline void xcl_btc1_clear_underflow_interrupt(void)
{
	XCL.INTFLAGS |= XCL_UNF1IF_bm;
}

/**
 * \brief XCL PEC0v퉺ꊄ荞ݗv׸ނ
 *
 * ̊֐XCL PEC0ꊄ荞ݗv׸ނ܂B
 *
 */
static inline void xcl_pec0_clear_interrupt(void)
{
	XCL.INTFLAGS |= XCL_PEC0IF_bm;
}

/**
 * \brief XCL PEC1v퉺ꊄ荞ݗv׸ނ
 *
 * ̊֐XCL PEC1ꊄ荞ݗv׸ނ܂B
 *
 */
static inline void xcl_pec1_clear_interrupt(void)
{
	XCL.INTFLAGS |= XCL_PEC1IF_bm;
}

/**
 * \brief XCL TC16vr/ߊl荞ݗv׸ނ
 *
 * ̊֐XCL TC16r/ߊl荞ݗv׸ނ܂B
 *
 */
static inline void xcl_tc16_clear_cc_interrupt(void)
{
	XCL.INTFLAGS |= XCL_CC0IF_bm;
}

/**
 * \brief XCL BTC0vr/ߊl荞ݗv׸ނ
 *
 * ̊֐XCL BTC0r/ߊl荞ݗv׸ނ܂B
 *
 */
static inline void xcl_btc0_clear_cc_interrupt(void)
{
	XCL.INTFLAGS |= XCL_CC0IF_bm;
}

/**
 * \brief XCL BTC1vr/ߊl荞ݗv׸ނ
 *
 * ̊֐XCL BTC1r/ߊl荞ݗv׸ނ܂B
 *
 */
static inline void xcl_btc1_clear_cc_interrupt(void)
{
	XCL.INTFLAGS |= XCL_CC1IF_bm;
}

/** @} */ /* xcl_tc_it */

/**
 * \brief XCL TC16vvlݒ
 *
 * ̊֐XCL TC16vwlɐݒ肵܂B
 *
 * \param  count vl
 */
static inline void xcl_tc16_set_count(uint16_t count)
{
	XCL.CNTL = LSB(count);
	XCL.CNTH = MSB(count);
}

/**
 * \brief XCL BTC0vvlݒ
 *
 * ̊֐XCL BTC0vwlɐݒ肵܂B
 *
 * \param  count vl
 */
static inline void xcl_btc0_set_count(uint8_t count)
{
	XCL.CNTL = count;
}

/**
 * \brief XCL BTC1vvlݒ
 *
 * ̊֐XCL BTC1vwlɐݒ肵܂B
 *
 * \param  count vl
 */
static inline void xcl_btc1_set_count(uint8_t count)
{
	XCL.CNTH = count;
}

/**
 * \brief XCL PEC0vvlݒ
 *
 * ̊֐XCL PEC0vwlɐݒ肵܂B
 *
 * \param  count vl
 */
static inline void xcl_pec0_set_count(uint8_t count)
{
	XCL.CNTL = count;
}

/**
 * \brief XCL PEC1vvlݒ
 *
 * ̊֐XCL PEC1vwlɐݒ肵܂B
 *
 * \param  count vl
 */
static inline void xcl_pec1_set_count(uint8_t count)
{
	XCL.CNTH = count;
}

/**
 * \brief XCL PENݒ
 *
 * ̊֐͊gꂽڰђ𐶐邽߂USART܂SPI̒PʕƋ
 * XCLPECŎgp鎞ڰђ`Ԑݒ肵܂B
 *
 * \param  lenght (ޯĐł)PECڰђ
 */
static inline void xcl_pec_set_lenght(uint8_t lenght)
{
	XCL.PLC = lenght;
}

/**
 * \ingroup xcl_tc_group
 * \defgroup xcl_tc_pwm XMEGA_H(XCL)PXPWMłT/C
 *
 * ̌QXCLTC⏕PʕPXPWM(SINGLE SLOPE PWM)̎Ɏgp邱
 * Ƃł֐񋟂܂B
 *
 * @{
 */

/**
 * \brief XCL TC16rlݒ
 *
 * ̊֐XCL TC16rڼ޽ɗvꂽlݒ肵܂B
 *
 * \param  compare XCL TC16rl
 */
static inline void xcl_tc16_set_compare(uint16_t compare)
{
	XCL.CMPL = LSB(compare);
	XCL.CMPH = MSB(compare);
}

/**
 * \brief XCL BTC0rlݒ
 *
 * ̊֐XCL BTC0rڼ޽ɗvꂽlݒ肵܂B
 *
 * \param  compare XCL BTC0rl
 */
static inline void xcl_btc0_set_compare(uint8_t compare)
{
	XCL.CMPL = LSB(compare);
}

/**
 * \brief XCL BTC1rlݒ
 *
 * ̊֐XCL BTC1rڼ޽ɗvꂽlݒ肵܂B
 *
 * \param  compare XCL BTC1rl
 */
static inline void xcl_btc1_set_compare(uint8_t compare)
{
	XCL.CMPH = LSB(compare);
}

/** @} */ /* xcl_tc_pwm */

/**
 * \ingroup xcl_tc_group
 * \defgroup xcl_tc_capture XMEGA_H(XCL)ߊlłT/C
 *
 * ̌QXCL TC⏕Pʕߊl(CAPTURE)̎ɂgp邱Ƃł
 * 񋟂܂B
 *
 * @{
 */

/**
 * \brief XCL TC16ߊll擾
 *
 * ̊֐XCL TC16ߊllԂ܂B
 *
 * \retval ߊll
 */
static inline uint16_t  xcl_tc16_get_capture(void)
{
	return (XCL.PERCAPTH << 8) + XCL.PERCAPTL;
}

/**
 * \brief XCL BTC0ߊll擾
 *
 * ̊֐XCL BTC0ߊllԂ܂B
 *
 * \retval ߊll
 */
static inline uint8_t  xcl_btc0_get_capture(void)
{
	return XCL.PERCAPTL;
}

/**
 * \brief XCL BTC1ߊll擾
 *
 * ̊֐XCL BTC1ߊllԂ܂B
 *
 * \retval ߊll
 */
static inline uint8_t  xcl_btc1_get_capture(void)
{
	return XCL.PERCAPTH;
}

/** @} */ /* xcl_tc_capture */

/**
 * \ingroup xcl_tc_group
 * \defgroup xcl_tc_normal XMEGA_H(XCL)WłT/C
 *
 * ̌QXCL TC⏕PʕW(NORMAL)̎ɂgp邱Ƃł֐
 * 񋟂܂B
 *
 * @{
 */

/**
 * \brief XCL TC16()ݒ
 *
 * ̊֐XCL TC16̎()ݒ肵܂B
 *
 * \param  period vꂽXCL TC16()
 */
static inline void xcl_tc16_set_period(uint16_t period)
{
	XCL.PERCAPTL = LSB(period);
	XCL.PERCAPTH = MSB(period);
}

/**
 * \brief XCL BTC0()ݒ
 *
 * ̊֐XCL BTC0̎()ݒ肵܂B
 *
 * \param  period vꂽXCL BTC0()
 */
static inline void xcl_btc0_set_period(uint8_t period)
{
	XCL.PERCAPTL = LSB(period);
}

/**
 * \brief XCL BTC1()ݒ
 *
 * ̊֐XCL BTC1̎()ݒ肵܂B
 *
 * \param  period vꂽXCL BTC1()
 */
static inline void xcl_btc1_set_period(uint8_t period)
{
	XCL.PERCAPTH = MSB(period);
}

/** @} */ /* xcl_tc_normal */

uint32_t xcl_tc_set_resolution(uint32_t resolution);

/** @} */

#ifdef __cplusplus
}
#endif

#endif  /* _XCL_TIMER_H_ */
