/**
 * \file
 *
 * \brief ߓL ۯǗ֐
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef XMEGA_SYSCLK_H_INCLUDED
#define XMEGA_SYSCLK_H_INCLUDED

#include <board.h>
#include <compiler.h>
#include <parts.h>
#include <ccp.h>
#include <osc.h>
#include <pll.h>

// ۼުėpۯ`Ԑݒݸٰ
#include <conf_clock.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \page sysclk_quickstart  ۯǗ޽(XMEGA)pJn̎
 *
 * ͓̎gp̏ꍇɑ΂Ļ޽`Ԑݒ肵Ďgp@̒iKIȎw
 * ł \ref sysclk_group " ۯǗ"޽pJn̎łB
 *
 * \section sysclk_quickstart_usecases  ۯǗgp
 * - \ref sysclk_quickstart_basic
 * - \ref sysclk_quickstart_use_case_2
 * - \ref sysclk_quickstart_use_case_3
 *
 * \section sysclk_quickstart_basic  ۯǗ޽̊{IȎg
 * {ͼ ۯǗ޽ɑ΂{IȎgpʂ񎦂܂B̏ʂϲ
 *  ۰ׂɎtꂽؽق̎g{̂ɓPLLPʕpĎ弽
 *  ۯ32MHzɌ`Ԑݒ肵܂BhIȎ޽ ۯCPUۯ͎弽 ۯ̑
 * xጸ܂B
 *
 * \subsection sysclk_quickstart_use_case_1_prereq OKv
 *  - Ȃ
 *
 * \subsection sysclk_quickstart_use_case_1_setup_steps 
 * ȉpނɒǉĂB
 * \code
 *    sysclk_init();
 * \endcode
 *
 * \subsection sysclk_quickstart_use_case_1_setup_steps_workflow Ƃ̗
 * -# conf_clock.h̐ݒɏ]ļ ۯ`Ԑݒ肵ĂB
 *    \code sysclk_init(); \endcode
 *
 * \subsection sysclk_quickstart_use_case_1_example_code ޗ
 *   Ȃconf_clock.hͯ ̧قňȉǉ܂͒߂OAق̑
 *   ̑SĂ̒`𒍎߂ɂĂB
 *   \code
 *   #define CONFIG_SYSCLK_SOURCE		SYSCLK_SRC_PLL
 *
 *   // Fpll0 = (Fclk * PLL_mul) / PLL_div
 *   #define CONFIG_PLL0_SOURCE			PLL_SRC_XOSC
 *   #define CONFIG_PLL0_MUL			(32000000UL / BOARD_XOSC_HZ)
 *   #define CONFIG_PLL0_DIV			1
 *
 *   // Fbus = Fsys / (2 ^ BUS_div)
 *   #define CONFIG_SYSCLK_PSADIV		SYSCLK_PSADIV_1
 *   #define CONFIG_SYSCLK_PSBCDIV		SYSCLK_PSBCDIV_1_2
 *   \endcode
 *
 * \subsection sysclk_quickstart_use_case_1_example_workflow Ƃ̗
 *  -# ƂPLLPʕ̏o͂gp悤Ɏ弽 ۯ`Ԑݒ肵ĂB
 *   \code #define CONFIG_SYSCLK_SOURCE		SYSCLK_SRC_PLL \endcode
 *  -# ƂĊOؽٗpUXOSCgp悤PLL0Pʕ`Ԑݒ肵ĂB
 *   \code #define CONFIG_PLL0_SOURCE		PLL_SRC_XOSC \endcode
 *  -# OUOSCő32MHzɒ{悤PLL0Pʕ`Ԑݒ肵ĂB
 *   \code
 *   #define CONFIG_PLL0_MUL			(32000000UL / BOARD_XOSC_HZ)
 *   #define CONFIG_PLL0_DIV			1
 *   \endcode
 *   \note gpҊɂāA \c BOARD_XOSC_HZ XOSCɎtꂽؽق
 *         gƂ \c conf_board.h `Ԑݒ̧قŒ`ׂłB
 *  -# CPUۯƒᑬ޽16MHzsA޽S32MHzős
 *     Ɍ`Ԑݒ肵ĂB
 *    \code
 *    #define CONFIG_SYSCLK_PSADIV		SYSCLK_PSADIV_1
 *    #define CONFIG_SYSCLK_PSBCDIV		SYSCLK_PSBCDIV_1_2
 *    \endcode
 *    \note ͑̕Wł2ׂ̂łBe
 *          `̏Œ߂conf_clock.h`̎QƂĂB
 */

/**
 * \page sysclk_quickstart_use_case_2 xȎgp - ޽ ۯǗ(XMEGA)
 *
 * \section sysclk_quickstart_use_case_2 xȎgp - ޽ ۯǗ
 * {ͼ ۯǗ޽ɑ΂ĂƍxȎgpʂ񎦂܂B̎gp
 * ʂϲ ۰ׂɎtꂽؽق̎g{̂ɓPLLPʕ
 * gpĎ弽 ۯ32MHzɌ`Ԑݒ肵܂B޽ ۯCPUۯƓx
 * ősAUSBۯ͍ZQƊƂUSBڰъJn48MHzɍZꂽ(
 * )32MHz RCUgp悤Ɍ`Ԑݒ肵܂B
 *
 * \subsection sysclk_quickstart_use_case_2_prereq OKv
 *  - Ȃ
 *
 * \subsection sysclk_quickstart_use_case_2_setup_steps 
 * ȉpނɒǉĂB
 * \code
 *    sysclk_init();
 * \endcode
 *
 * \subsection sysclk_quickstart_use_case_2_setup_steps_workflow Ƃ̗
 * -# conf_clock.h̐ݒɏ]ļ ۯ`Ԑݒ肵ĂB
 *    \code sysclk_init(); \endcode
 *
 * \subsection sysclk_quickstart_use_case_2_example_code ޗ
 *   Ȃconf_clock.hͯ ̧قňȉǉ܂͒߂OAق̑
 *   ̑SĂ̒`𒍎߂ɂĂB
 *   \code
 *   #define CONFIG_SYSCLK_SOURCE		SYSCLK_SRC_PLL
 *
 *   // Fpll0 = (Fclk * PLL_mul) / PLL_div
 *   #define CONFIG_PLL0_SOURCE			PLL_SRC_XOSC
 *   #define CONFIG_PLL0_MUL			(32000000UL / BOARD_XOSC_HZ)
 *   #define CONFIG_PLL0_DIV			1
 *
 *   // Fbus = Fsys / (2 ^ BUS_div)
 *   #define CONFIG_SYSCLK_PSADIV		SYSCLK_PSADIV_1
 *   #define CONFIG_SYSCLK_PSBCDIV		SYSCLK_PSBCDIV_1_1
 *
 *   #define CONFIG_USBCLK_SOURCE		USBCLK_SRC_RCOSC
 *   #define CONFIG_OSC_RC32_CAL		48000000UL
 *   #define CONFIG_OSC_AUTOCAL			OSC_ID_RC32MHZ
 *   #define CONFIG_OSC_AUTOCAL_REF_OSC	OSC_ID_USBSOF
 *   \endcode
 *
 * \subsection sysclk_quickstart_use_case_2_example_workflow Ƃ̗
 *  -# ƂPLLPʕ̏o͂gp悤Ɏ弽 ۯ`Ԑݒ肵ĂB
 *   \code #define CONFIG_SYSCLK_SOURCE		SYSCLK_SRC_PLL \endcode
 *  -# ƂĊOؽٗpUXOSCgp悤PLL0Pʕ`Ԑݒ肵ĂB
 *   \code #define CONFIG_PLL0_SOURCE		PLL_SRC_XOSC \endcode
 *  -# OUOSCő32MHzɒ{悤PLL0Pʕ`Ԑݒ肵ĂB
 *   \code
 *   #define CONFIG_PLL0_MUL				(32000000UL / BOARD_XOSC_HZ)
 *   #define CONFIG_PLL0_DIV				1
 *   \endcode
 *   \note gpҊɂāA \c BOARD_XOSC_HZ XOSCɎtꂽؽق
 *         gƂ \c conf_board.h `Ԑݒ̧قŒ`ׂłB
 *  -# CPUƎ޽ ۯ32MHzős悤Ɍ`ԐݒĂB
 *    \code
 *    #define CONFIG_SYSCLK_PSADIV			SYSCLK_PSADIV_1
 *    #define CONFIG_SYSCLK_PSBCDIV			SYSCLK_PSBCDIV_1_2
 *    \endcode
 *    \note ͑̕Wł2ׂ̂łBe
 *          `̏Œ߂conf_clock.h`̎QƂĂB
 *  -# (32MHz)RCUg悤USBPʕۯ`Ԑݒ肵ĂB
 *    \code
 *    #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_RCOSC
 *    \endcode
 *    \note RCU킪USBPʕpɎgp鎞ɁAUSBӋ@\@\
 *          48MHzɍčZȂ΂Ȃ܂B̔U킪̌ɼ 
 *          ۯƂĎgpꍇAeőCPUg𒴂ȂƂۏ
 *          邽߂ɁA̸ۯ͎ӂCPU޽ ۯ萔oRŕ
 *          ΂Ȃ܂B
 *  -# ZQƊƂUSBڰъJn(SOF)p48MHzɍZ悤ɓ
 *     (32MHz)RCU`Ԑݒ肵ĂB
 *    \code
 *    #define CONFIG_OSC_RC32_CAL			48000000UL
 *    #define CONFIG_OSC_AUTOCAL			OSC_ID_RC32MHZ
 *    #define CONFIG_OSC_AUTOCAL_REF_OSC	OSC_ID_USBSOF
 *    \endcode
 */

/**
 * \page sysclk_quickstart_use_case_3 xȎgp - DFLLZ(XMEGA)
 *
 * \section sysclk_quickstart_use_case_3 xȎgp - DFLLZ
 * {ͼ ۯǗ޽ɑ΂ƍxȎgpʂ񎦂܂B̎gp
 * ʂ͓32kHzUɑ΂čZꂽ2MHz RCUgpĎ弽 
 * ۯ2MHzɌ`Ԑݒ肵܂B޽ ۯCPUۯƓxősAUSBۯ
 * USBۯ͍ZQƊƂUSBڰъJn48MHzɍZꂽ()32MHz 
 * RCUgp悤Ɍ`Ԑݒ肵܂B
 *
 * \subsection sysclk_quickstart_use_case_3_prereq OKv
 *  - None
 *
 * \subsection sysclk_quickstart_use_case_3_setup_steps 
 * ȉpނɒǉĂB
 * \code
 *    sysclk_init();
 * \endcode
 *
 * \subsection sysclk_quickstart_use_case_3_setup_steps_workflow Ƃ̗
 * -# conf_clock.h̐ݒɏ]ļ ۯ`Ԑݒ肵ĂB
 *    \code sysclk_init(); \endcode
 *
 * \subsection sysclk_quickstart_use_case_3_example_code ޗ
 *   Ȃconf_clock.hͯ ̧قňȉǉ܂͒߂OAق̑
 *   ̑SĂ̒`𒍎߂ɂĂB
 *   \code
 *   #define CONFIG_SYSCLK_SOURCE				SYSCLK_SRC_RC2MHZ
 *
 *   #define CONFIG_OSC_AUTOCAL_RC2MHZ_REF_OSC	OSC_ID_RC32KHZ
 *
 *   #define CONFIG_USBCLK_SOURCE				USBCLK_SRC_RCOSC
 *   #define CONFIG_OSC_RC32_CAL				48000000UL
 *   #define CONFIG_OSC_AUTOCAL_RC32MHZ_REF_OSC	OSC_ID_USBSOF
 *   \endcode
 *
 * \subsection sysclk_quickstart_use_case_3_example_workflow Ƃ̗
 *  -# Ƃē2MHz RCUgp悤Ɏ弽 ۯ`Ԑݒ肵ĂB
 *   \code
 *   #define CONFIG_SYSCLK_SOURCE				SYSCLK_SRC_RC2MHZ
 *   \endcode
 *  -# 32kHz RCUgp悤2MHz DFLLZ`Ԑݒ肵ĂB
 *   \code
 *   #define CONFIG_OSC_AUTOCAL_RC2MHZ_REF_OSC	OSC_ID_RC32KHZ
 *   \endcode
 *   \note ZɂĂ͈ʓIɊO32kHzؽقgK؂łB
 *         ɂ̏ꍇ͑OSC_ID_XOSCgĂB
 *  -# (32MHz)RCUg悤USBPʕۯ`Ԑݒ肵ĂB
 *   \code
 *   #define CONFIG_USBCLK_SOURCE				USBCLK_SRC_RCOSC
 *   \endcode
 *  -# ZQƊƂUSBڰъJn(SOF)p48MHzɍZ悤ɓ
 *     (32MHz)RCU`Ԑݒ肵ĂB
 *   \code
 *   #define CONFIG_USBCLK_SOURCE				USBCLK_SRC_RCOSC
 *   #define CONFIG_OSC_RC32_CAL				48000000UL
 *   #define CONFIG_OSC_AUTOCAL_RC32MHZ_REF_OSC	OSC_ID_USBSOF
 *   \endcode
 */

/* configV̂ɕ */
#ifdef CONFIG_OSC_AUTOCAL
# if CONFIG_OSC_AUTOCAL == OSC_ID_RC2MHZ
#  define CONFIG_OSC_AUTOCAL_RC2MHZ_REF_OSC CONFIG_OSC_AUTOCAL_REF_OSC
# elif CONFIG_OSC_AUTOCAL == OSC_ID_RC32MHZ
#  define CONFIG_OSC_AUTOCAL_RC32MHZ_REF_OSC CONFIG_OSC_AUTOCAL_REF_OSC
# else
#  error Bad configuration of CONFIG_OSC_AUTOCAL and/or CONFIG_OSC_AUTOCAL_REF_OSC
# endif
#endif

// configȂOuȂ2MHzgp
#ifndef CONFIG_SYSCLK_SOURCE
# define CONFIG_SYSCLK_SOURCE	SYSCLK_SRC_RC2MHZ
#endif /* CONFIG_SYSCLK_SOURCE */

#ifndef CONFIG_SYSCLK_PSADIV
# define CONFIG_SYSCLK_PSADIV	SYSCLK_PSADIV_1
#endif /* CONFIG_SYSCLK_PSADIV */

#ifndef CONFIG_SYSCLK_PSBCDIV
# define CONFIG_SYSCLK_PSBCDIV	SYSCLK_PSBCDIV_1_1
#endif /* CONFIG_SYSCLK_PSBCDIV */

/**
 * \weakgroup sysclk_group
 *
 * \section sysclk_group_config `Ԑݒ
 *
 * ȉ̌`Ԑݒق͏ ۯ`Ԑݒw肷̂Ɏgp邩
 * ܂Bق̉ꂩݒ肳ȂꍇAÓȊ肪񋟂܂B
 *   - \b CONFIG_SYSCLK_SOURCE	:  ۯK
 *   - \b CONFIG_SYSCLK_PSADIV	: OuAݒ
 *   - \b CONFIG_SYSCLK_PSBCDIV	: OuBݒ
 *   - \b CONFIG_USBCLK_SOURCE	: USBۯ
 *
 * @{
 */

//! \name  ۯ
//@{
//! 2MHz RCU
#define SYSCLK_SRC_RC2MHZ	CLK_SCLKSEL_RC2M_gc
//! 32MHz RCU
#define SYSCLK_SRC_RC32MHZ	CLK_SCLKSEL_RC32M_gc
//! 32kHz RCU
#define SYSCLK_SRC_RC32KHZ	CLK_SCLKSEL_RC32K_gc
//! OU
#define SYSCLK_SRC_XOSC		CLK_SCLKSEL_XOSC_gc
//! ʑŒ艻H(PLL)
#define SYSCLK_SRC_PLL		CLK_SCLKSEL_PLL_gc
#if XMEGA_E
//! 8MHz RCU
# define SYSCLK_SRC_RC8MHZ	CLK_SCLKSEL_RC8M_gc
#endif
//@}

//! \name OuAݒ(CLKsysɊ֌W)
//@{
#define SYSCLK_PSADIV_1		CLK_PSADIV_1_gc		//!< OuȂ
#define SYSCLK_PSADIV_2		CLK_PSADIV_2_gc		//!< CLKper42Ou
#define SYSCLK_PSADIV_4		CLK_PSADIV_4_gc		//!< CLKper44Ou
#define SYSCLK_PSADIV_8		CLK_PSADIV_8_gc		//!< CLKper48Ou
#define SYSCLK_PSADIV_16	CLK_PSADIV_16_gc	//!< CLKper416Ou
#define SYSCLK_PSADIV_32	CLK_PSADIV_32_gc	//!< CLKper432Ou
#define SYSCLK_PSADIV_64	CLK_PSADIV_64_gc	//!< CLKper464Ou
#define SYSCLK_PSADIV_128	CLK_PSADIV_128_gc	//!< CLKper4128Ou
#define SYSCLK_PSADIV_256	CLK_PSADIV_256_gc	//!< CLKper4256Ou
#define SYSCLK_PSADIV_512	CLK_PSADIV_512_gc	//!< CLKper4512Ou

#if XMEGA_E
# define SYSCLK_PSADIV_6	CLK_PSADIV_6_gc		//!< CLKper46Ou
# define SYSCLK_PSADIV_10	CLK_PSADIV_10_gc	//!< CLKper410Ou
# define SYSCLK_PSADIV_12	CLK_PSADIV_12_gc	//!< CLKper412Ou
# define SYSCLK_PSADIV_24	CLK_PSADIV_24_gc	//!< CLKper424Ou
# define SYSCLK_PSADIV_48	CLK_PSADIV_48_gc	//!< CLKper448Ou
#endif
//@}

//! \name OuBC̐ݒ(CLKper4Ɋ֌W)
//@{
#define SYSCLK_PSBCDIV_1_1	CLK_PSBCDIV_1_1_gc	//! OuȂ
#define SYSCLK_PSBCDIV_1_2	CLK_PSBCDIV_1_2_gc	//! CLKperCLKcpu2Ou
#define SYSCLK_PSBCDIV_4_1	CLK_PSBCDIV_4_1_gc	//! CLKper2ACLKperACLKcpu4Ou
#define SYSCLK_PSBCDIV_2_2	CLK_PSBCDIV_2_2_gc	//! CLKper22OuACLKperCLKcpu4Ou
//@}

//! \name  ۯ ߰Ĕԍ
enum sysclk_port_id {
	SYSCLK_PORT_GEN,	//!< ߰ĂƘAgȂ޲
	SYSCLK_PORT_A,		//!< PORTA޲
	SYSCLK_PORT_B,		//!< PORTB޲
	SYSCLK_PORT_C,		//!< PORTC޲
	SYSCLK_PORT_D,		//!< PORTD޲
	SYSCLK_PORT_E,		//!< PORTE޲
	SYSCLK_PORT_F,		//!< PORTF޲
};

/*! \name ǂ߰ĂƂAgȂۯ
 *
 * \note ޲ŗp\ȒPʕɂĂްĂB
 */
//@{
#define SYSCLK_DMA		PR_DMA_bm		//!< DMA
#define SYSCLK_EDMA		PR_EDMA_bm		//!< EDMA
#define SYSCLK_EVSYS	PR_EVSYS_bm		//!< ۼ
#define SYSCLK_RTC		PR_RTC_bm		//!< Ԍv
#define SYSCLK_EBI		PR_EBI_bm		//!< O޽ ̪
#define SYSCLK_AES		PR_AES_bm		//!< AESPʕ
#define SYSCLK_USB		PR_USB_bm		//!< USBPʕ
#define SYSCLK_XCL		PR_XCL_bm		//!< XMEGA_HPʕ
//@}

/*! \name PORTAPORTBł̸ۯ
 *
 * \note ޲ŗp\ȒPʕɂĂްĂB
 */
//@{
#define SYSCLK_AC		PR_AC_bm		//!< ۸ޔr
#define SYSCLK_ADC		PR_ADC_bm		//!< A/Dϊ
#define SYSCLK_DAC		PR_DAC_bm		//!< D/Aϊ
//@}

/*! \name PORTCAPORTDAPORTEAPORTFł̸ۯ
 *
 * \note ޲ŗp\ȒPʕɂĂްĂB
 */
//@{
#define SYSCLK_TC0		PR_TC0_bm		//!< /0
#define SYSCLK_TC1		PR_TC1_bm		//!< /1
#define SYSCLK_TC4		PR_TC4_bm		//!< /4
#define SYSCLK_TC5		PR_TC5_bm		//!< /5
#define SYSCLK_HIRES	PR_HIRES_bm		//!< \g
#define SYSCLK_SPI		PR_SPI_bm		//!< SPI
#define SYSCLK_USART0	PR_USART0_bm	//!< USART 0
#define SYSCLK_USART1	PR_USART1_bm	//!< USART 1
#define SYSCLK_TWI		PR_TWI_bm		//!< TWI
//@}

/**
 * \name RTCۯʎq
 *
 * @{
 */

#define SYSCLK_RTCSRC_ULP		CLK_RTCSRC_ULP_gc		//!< ULPU킩1kHz (ᐸx)
#define SYSCLK_RTCSRC_TOSC		CLK_RTCSRC_TOSC_gc		//!< 32.768kHzؽٔU(TOSC)1.024kHz
#define SYSCLK_RTCSRC_RCOSC		CLK_RTCSRC_RCOSC_gc		//!< 32.768kHzRCU킩1.024kHz
#define SYSCLK_RTCSRC_TOSC32	CLK_RTCSRC_TOSC32_gc	//!< ؽٗpU(TOSC)32.768kHz
#define SYSCLK_RTCSRC_RCOSC32	CLK_RTCSRC_RCOSC32_gc	//!< RCU킩32.768kHz
#define SYSCLK_RTCSRC_EXTCLK	CLK_RTCSRC_EXTCLK_gc	//!< TOSC1ł̊Oۯ

/** @} */

#if XMEGA_AU || XMEGA_B || XMEGA_C
//! \name USBۯ
//@{
#define USBCLK_SRC_RCOSC	0	//!< 32MHz RCU
#define USBCLK_SRC_PLL		1	//!< ʑŒ艻H(PLL)
//@}

/**
 * \def CONFIG_USBCLK_SOURCE
 * \brief USBۯp`Ԑݒ
 *
 * ޲USBPʕƂAꂪgpӐ}ȂAۯ`ԐݒƋ
 * ɂ̼ق`Ȃ΂Ȃ܂B
 *
 * \c USBCLK_SRC_xxx `1ƂĂ`ĂBPLLI΂ꍇA
 * 48MHzős悤Ɍ`Ԑݒ肳Ȃ΂Ȃ܂B32MHz RCU킪I΂
 * ꍇADFLL̎iɂ48MHzɒȂ΂Ȃ܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_USBCLK_SOURCE
#endif

#endif // XMEGA_AU || XMEGA_B || XMEGA_C

#ifndef __ASSEMBLY__

/**
 * \name  ۯƂ̕zۯ̖₢킹
 */
//@{

/**
 * \brief 弽 ۯHzł݂̌̑xԂ܂B
 *
 * \todo ̊֐͎ۯ͈U\ݒ肳ƌĕύXꂸAPLL0߲
 *       Ɍ`Ԑݒ肳ꂽ葬xŏɑsƉ肵܂Bꂪł
 *       ʓIȌ`ԐݒłƓɁAX͐\̗R̂߂̓ʂȏꍇƂ
 *       x邱Ƃ]݁A̓_ōXɂƓIȍ\ݒx邱
 *       ƂKvłB
 *
 * \return Hzł̎弽 ۯ̎g
 */
static inline uint32_t sysclk_get_main_hz(void)
{
	switch (CONFIG_SYSCLK_SOURCE) {
	case SYSCLK_SRC_RC2MHZ:
		return 2000000UL;
#if XMEGA_E
	case SYSCLK_SRC_RC8MHZ:
		return 8000000UL;
#endif
	case SYSCLK_SRC_RC32MHZ:
#ifdef CONFIG_OSC_RC32_CAL
		return CONFIG_OSC_RC32_CAL;
#else
		return 32000000UL;
#endif

	case SYSCLK_SRC_RC32KHZ:
		return 32768UL;

#ifdef BOARD_XOSC_HZ
	case SYSCLK_SRC_XOSC:
		return BOARD_XOSC_HZ;
#endif

#ifdef CONFIG_PLL0_SOURCE
	case SYSCLK_SRC_PLL:
		return pll_get_default_rate(0);
#endif

	default:
		// unhandled_case(CONFIG_SYSCLK_SOURCE);
		return 0;
	}
}

/**
 * \brief Hzclk_PER4݂̌̑xԂ܂B
 *
 * ̸ۯCPUۯő4{s邱Ƃł܂B
 *
 * \return Hzłclk_PER4ۯ̎g
 */
static inline uint32_t sysclk_get_per4_hz(void)
{
	uint8_t shift = 0;

#if XMEGA_E
	if (CONFIG_SYSCLK_PSADIV > SYSCLK_PSADIV_512) {
		switch (CONFIG_SYSCLK_PSADIV) {
			case SYSCLK_PSADIV_6:
				return sysclk_get_main_hz() / 6;
			case SYSCLK_PSADIV_10:
				return sysclk_get_main_hz() / 10;
			case SYSCLK_PSADIV_12:
				return sysclk_get_main_hz() / 12;
			case SYSCLK_PSADIV_24:
				return sysclk_get_main_hz() / 24;
			case SYSCLK_PSADIV_48:
				return sysclk_get_main_hz() / 48;
			default:
				// unhandled_case;
				return 0;
		}
	}
#endif
	if (CONFIG_SYSCLK_PSADIV & (1U << CLK_PSADIV_gp)) {
		shift = (CONFIG_SYSCLK_PSADIV >> (1 + CLK_PSADIV_gp)) + 1;
	}

	return sysclk_get_main_hz() >> shift;
}

/**
 * \brief Hzclk_PER2݂̌̑xԂ܂B
 *
 * ̸ۯCPUۯő2{s邱Ƃł܂B
 *
 * \return Hzłclk_PER2ۯ̎g
 */
static inline uint32_t sysclk_get_per2_hz(void)
{
	switch (CONFIG_SYSCLK_PSBCDIV) {
	case SYSCLK_PSBCDIV_1_1: /*  */
	case SYSCLK_PSBCDIV_1_2:
		return sysclk_get_per4_hz();

	case SYSCLK_PSBCDIV_4_1:
		return sysclk_get_per4_hz() / 4;

	case SYSCLK_PSBCDIV_2_2:
		return sysclk_get_per4_hz() / 2;

	default:
		// unhandled_case(CONFIG_SYSCLK_PSBCDIV);
		return 0;
	}
}

/**
 * \brief Hzclk_PEŘ݂̑xԂ܂B
 *
 * ̸ۯ͕킪ݒ肳ȂACPUۯƓxős܂B
 *
 * \return Hzłclk_PERۯ̎g
 */
static inline uint32_t sysclk_get_per_hz(void)
{
	if (CONFIG_SYSCLK_PSBCDIV & (1U << CLK_PSBCDIV_gp))
		return sysclk_get_per2_hz() / 2;
	else
		return sysclk_get_per2_hz();
}

/**
 * \brief HzCPUۯ݂̌̑xԂ܂B
 *
 * \return HzłCPUۯ̎g
 */
static inline uint32_t sysclk_get_cpu_hz(void)
{
	return sysclk_get_per_hz();
}

/**
 * \brief w肳ꂽӋ@\Ɏtꂽ޽ ۯ̌ݑxHzŎ擾
 *
 * \param  module Pʕ̊ڽւ̈ʒuwq
 *
 * \return w肳ꂽӋ@\Ɏtꂽ޽Hzł̎g
 */
static inline uint32_t sysclk_get_peripheral_bus_hz(const volatile void *module)
{
	if (module == NULL) {
		Assert(false);
		return 0;
	}
#ifdef AES
	else if (module == &AES) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef EBI
	else if (module == &EBI) {
		return sysclk_get_per2_hz();
	}
#endif
#ifdef RTC
	else if (module == &RTC) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef EVSYS
	else if (module == &EVSYS) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef DMA
	else if (module == &DMA) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef EDMA
	else if (module == &EDMA) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef ACA
	else if (module == &ACA) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef ACB
	else if (module == &ACB) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef ADCA
	else if (module == &ADCA) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef ADCB
	else if (module == &ADCB) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef DACA
	else if (module == &DACA) {
		return sysclk_get_per_hz();
	}
#endif
// XMEGA Dͯ ̧ٗp΍
#if !XMEGA_D
#ifdef DACB
	else if (module == &DACB) {
		return sysclk_get_per_hz();
	}
#endif
#endif // ΍I
#ifdef FAULTC0
	else if (module == &FAULTC0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef FAULTC1
	else if (module == &FAULTC1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCC0
	else if (module == &TCC0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCD0
	else if (module == &TCD0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCE0
	else if (module == &TCE0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCF0
	else if (module == &TCF0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCC1
	else if (module == &TCC1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCD1
	else if (module == &TCD1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCE1
	else if (module == &TCE1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCF1
	else if (module == &TCF1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCC4
	else if (module == &TCC4) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCC5
	else if (module == &TCC5) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCD4
	else if (module == &TCD4) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TCD5
	else if (module == &TCD5) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef HIRESC
	else if (module == &HIRESC) {
		return sysclk_get_per4_hz();
	}
#endif
#ifdef HIRESD
	else if (module == &HIRESD) {
		return sysclk_get_per4_hz();
	}
#endif
#ifdef HIRESE
	else if (module == &HIRESE) {
		return sysclk_get_per4_hz();
	}
#endif
#ifdef HIRESF
	else if (module == &HIRESF) {
		return sysclk_get_per4_hz();
	}
#endif
#ifdef SPIC
	else if (module == &SPIC) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef SPID
	else if (module == &SPID) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef SPIE
	else if (module == &SPIE) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef SPIF
	else if (module == &SPIF) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTC0
	else if (module == &USARTC0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTD0
	else if (module == &USARTD0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTE0
	else if (module == &USARTE0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTF0
	else if (module == &USARTF0) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTC1
	else if (module == &USARTC1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTD1
	else if (module == &USARTD1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTE1
	else if (module == &USARTE1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef USARTF1
	else if (module == &USARTF1) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TWIC
	else if (module == &TWIC) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TWID
	else if (module == &TWID) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TWIE
	else if (module == &TWIE) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef TWIF
	else if (module == &TWIF) {
		return sysclk_get_per_hz();
	}
#endif
#ifdef XCL
	else if (module == &XCL) {
		return sysclk_get_per_hz();
	}
#endif
	else {
		Assert(false);
		return 0;
	}
}

//@}

//! \name ۯ̋Ƌ֎~
//@{

/**
 * \brief \a port ̎Ӌ@\ \a id ւ̸ۯ
 *
 * \param  port Pʕ( \c SYSCLK_PORT_* `1)ڑ߰Ă̎ʎq
 * \param  id   Ӌ@\Pʕ̎ʎq(ޯĎՕ)
 */
extern void sysclk_enable_module(enum sysclk_port_id port, uint8_t id);

/**
 * \brief \a port ̎Ӌ@\ \a id ւ̸ۯ֎~
 *
 * \param  port Pʕ( \c SYSCLK_PORT_* `1)ڑ߰Ă̎ʎq
 * \param  id   ֎~Ӌ@\Pʕ̎ʎq(ޯĎՕ)
 */
extern void sysclk_disable_module(enum sysclk_port_id port, uint8_t id);

/**
 * \brief ڽӋ@\̸ۯ
 *
 *  ^ꂽ̊ڽŎӋ@\ւ̸ۯ܂BӋ@\HSB޽
 *  ŘAgۯȂA܂B
 *
 * \param  module Pʕڽւ̈ʒuwq
 */
static inline void sysclk_enable_peripheral_clock(const volatile void *module)
{
	if (module == NULL) {
		Assert(false);
	}
#ifdef AES
	else if (module == &AES) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_AES);
	}
#endif
#ifdef EBI
	else if (module == &EBI) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_EBI);
	}
#endif
#ifdef RTC
	else if (module == &RTC) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_RTC);
	}
#endif
#ifdef EVSYS
	else if (module == &EVSYS) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_EVSYS);
	}
#endif
#ifdef DMA
	else if (module == &DMA) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_DMA);
	}
#endif
#ifdef EDMA
	else if (module == &EDMA) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_EDMA);
	}
#endif
#ifdef ACA
	else if (module == &ACA) {
		sysclk_enable_module(SYSCLK_PORT_A, SYSCLK_AC);
	}
#endif
#ifdef ACB
	else if (module == &ACB) {
		sysclk_enable_module(SYSCLK_PORT_B, SYSCLK_AC);
	}
#endif
#ifdef ADCA
	else if (module == &ADCA) {
		sysclk_enable_module(SYSCLK_PORT_A, SYSCLK_ADC);
	}
#endif
#ifdef ADCB
	else if (module == &ADCB) {
		sysclk_enable_module(SYSCLK_PORT_B, SYSCLK_ADC);
	}
#endif
#ifdef DACA
	else if (module == &DACA) {
		sysclk_enable_module(SYSCLK_PORT_A, SYSCLK_DAC);
	}
#endif
// XMEGA Dͯ ̧ٗp΍
#if !XMEGA_D
#ifdef DACB
	else if (module == &DACB) {
		sysclk_enable_module(SYSCLK_PORT_B, SYSCLK_DAC);
	}
#endif
#endif // ΍I
#ifdef TCC0
	else if (module == &TCC0) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TC0);
	}
#endif
#ifdef TCD0
	else if (module == &TCD0) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_TC0);
	}
#endif
#ifdef TCE0
	else if (module == &TCE0) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_TC0);
	}
#endif
#ifdef TCF0
	else if (module == &TCF0) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_TC0);
	}
#endif
#ifdef TCC1
	else if (module == &TCC1) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TC1);
	}
#endif
#ifdef TCD1
	else if (module == &TCD1) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_TC1);
	}
#endif
#ifdef TCE1
	else if (module == &TCE1) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_TC1);
	}
#endif
#ifdef TCF1
	else if (module == &TCF1) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_TC1);
	}
#endif
#ifdef TCC4
	else if (module == &TCC4) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TC4);
	}
#endif
#ifdef TCC5
	else if (module == &TCC5) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TC5);
	}
#endif
#ifdef TCD4
	else if (module == &TCD4) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_TC4);
	}
#endif
#ifdef TCD5
	else if (module == &TCD5) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_TC5);
	}
#endif
#ifdef HIRESC
	else if (module == &HIRESC) {
			sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_HIRES);
	}
#endif
#ifdef HIRESD
	else if (module == &HIRESD) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_HIRES);
	}
#endif
#ifdef HIRESE
	else if (module == &HIRESE) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_HIRES);
	}
#endif
#ifdef HIRESF
	else if (module == &HIRESF) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_HIRES);
	}
#endif
#ifdef SPIC
	else if (module == &SPIC) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_SPI);
	}
#endif
#ifdef SPID
	else if (module == &SPID) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_SPI);
	}
#endif
#ifdef SPIE
	else if (module == &SPIE) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_SPI);
	}
#endif
#ifdef SPIF
	else if (module == &SPIF) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_SPI);
	}
#endif
#ifdef USARTC0
	else if (module == &USARTC0) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_USART0);
	}
#endif
#ifdef USARTD0
	else if (module == &USARTD0) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_USART0);
	}
#endif
#ifdef USARTE0
	else if (module == &USARTE0) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_USART0);
	}
#endif
#ifdef USARTF0
	else if (module == &USARTF0) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_USART0);
	}
#endif
#ifdef USARTC1
	else if (module == &USARTC1) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_USART1);
	}
#endif
#ifdef USARTD1
	else if (module == &USARTD1) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_USART1);
	}
#endif
#ifdef USARTE1
	else if (module == &USARTE1) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_USART1);
	}
#endif
#ifdef USARTF1
	else if (module == &USARTF1) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_USART1);
	}
#endif
#ifdef TWIC
	else if (module == &TWIC) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TWI);
	}
#endif
#ifdef TWID
	else if (module == &TWID) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_TWI);
	}
#endif
#ifdef TWIE
	else if (module == &TWIE) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_TWI);
	}
#endif
#ifdef TWIF
	else if (module == &TWIF) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_TWI);
	}
#endif
#ifdef XCL
	else if (module == &XCL) {
		sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_XCL);
	}
#endif
	else {
		Assert(false);
	}
}

/**
 * \brief ڽӋ@\ۯ֎~
 *
 *  ^ꂽ̊ڽŎӋ@\ւ̸ۯ֎~܂BӋ@\HSB޽
 *  ŘAgۯȂA֎~܂B
 *
 * \param  module Pʕڽւ̈ʒuwq
 */
static inline void sysclk_disable_peripheral_clock(const volatile void *module)
{
	if (module == NULL) {
		Assert(false);
	}
#ifdef AES
	else if (module == &AES) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_AES);
	}
#endif
#ifdef EBI
	else if (module == &EBI) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_EBI);
	}
#endif
#ifdef RTC
	else if (module == &RTC) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_RTC);
	}
#endif
#ifdef EVSYS
	else if (module == &EVSYS) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_EVSYS);
	}
#endif
#ifdef DMA
	else if (module == &DMA) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_DMA);
	}
#endif
#ifdef EDMA
	else if (module == &EDMA) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_EDMA);
	}
#endif
#ifdef ACA
	else if (module == &ACA) {
		sysclk_disable_module(SYSCLK_PORT_A, SYSCLK_AC);
	}
#endif
#ifdef ACB
	else if (module == &ACB) {
		sysclk_disable_module(SYSCLK_PORT_B, SYSCLK_AC);
	}
#endif
#ifdef ADCA
	else if (module == &ADCA) {
		sysclk_disable_module(SYSCLK_PORT_A, SYSCLK_ADC);
	}
#endif
#ifdef ADCB
	else if (module == &ADCB) {
		sysclk_disable_module(SYSCLK_PORT_B, SYSCLK_ADC);
	}
#endif
#ifdef DACA
	else if (module == &DACA) {
		sysclk_disable_module(SYSCLK_PORT_A, SYSCLK_DAC);
	}
#endif
// XMEGA Dͯ ̧ٗp΍
#if !XMEGA_D
#ifdef DACB
	else if (module == &DACB) {
		sysclk_disable_module(SYSCLK_PORT_B, SYSCLK_DAC);
	}
#endif
#endif // ΍I
#ifdef TCC0
	else if (module == &TCC0) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TC0);
	}
#endif
#ifdef TCD0
	else if (module == &TCD0) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_TC0);
	}
#endif
#ifdef TCE0
	else if (module == &TCE0) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_TC0);
	}
#endif
#ifdef TCF0
	else if (module == &TCF0) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_TC0);
	}
#endif
#ifdef TCC1
	else if (module == &TCC1) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TC1);
	}
#endif
#ifdef TCD1
	else if (module == &TCD1) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_TC1);
	}
#endif
#ifdef TCE1
	else if (module == &TCE1) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_TC1);
	}
#endif
#ifdef TCF1
	else if (module == &TCF1) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_TC1);
	}
#endif
#ifdef TCC4
	else if (module == &TCC4) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TC4);
	}
#endif
#ifdef TCC5
	else if (module == &TCC5) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TC5);
	}
#endif
#ifdef TCD4
	else if (module == &TCD4) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_TC4);
	}
#endif
#ifdef TCD5
	else if (module == &TCD5) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_TC5);
	}
#endif
#ifdef HIRESC
	else if (module == &HIRESC) {
			sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_HIRES);
	}
#endif
#ifdef HIRESD
	else if (module == &HIRESD) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_HIRES);
	}
#endif
#ifdef HIRESE
	else if (module == &HIRESE) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_HIRES);
	}
#endif
#ifdef HIRESF
	else if (module == &HIRESF) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_HIRES);
	}
#endif
#ifdef SPIC
	else if (module == &SPIC) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_SPI);
	}
#endif
#ifdef SPID
	else if (module == &SPID) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_SPI);
	}
#endif
#ifdef SPIE
	else if (module == &SPIE) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_SPI);
	}
#endif
#ifdef SPIF
	else if (module == &SPIF) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_SPI);
	}
#endif
#ifdef USARTC0
	else if (module == &USARTC0) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_USART0);
	}
#endif
#ifdef USARTD0
	else if (module == &USARTD0) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_USART0);
	}
#endif
#ifdef USARTE0
	else if (module == &USARTE0) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_USART0);
	}
#endif
#ifdef USARTF0
	else if (module == &USARTF0) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_USART0);
	}
#endif
#ifdef USARTC1
	else if (module == &USARTC1) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_USART1);
	}
#endif
#ifdef USARTD1
	else if (module == &USARTD1) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_USART1);
	}
#endif
#ifdef USARTE1
	else if (module == &USARTE1) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_USART1);
	}
#endif
#ifdef USARTF1
	else if (module == &USARTF1) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_USART1);
	}
#endif
#ifdef TWIC
	else if (module == &TWIC) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TWI);
	}
#endif
#ifdef TWID
	else if (module == &TWID) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_TWI);
	}
#endif
#ifdef TWIE
	else if (module == &TWIE) {
		sysclk_disable_module(SYSCLK_PORT_E, SYSCLK_TWI);
	}
#endif
#ifdef TWIF
	else if (module == &TWIF) {
		sysclk_disable_module(SYSCLK_PORT_F, SYSCLK_TWI);
	}
#endif
#ifdef XCL
	else if (module == &XCL) {
		sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_XCL);
	}
#endif
	else {
		Assert(false);
	}
}

/**
 * \brief Pʕɑ΂ēۯĂ邩
 *
 * \param  port Pʕ( \c SYSCLK_PORT_* `1)ڑ߰Ă̎ʎq
 * \param  id   ( \c SYSCLK_* Pʕ`1)ׂ邽߂̎Ӌ@\Pʕ̎
 *			    ʎq(ޯĎՕ)
 *
 * \retval true  \a port ̒Pʕ \a id ɑ΂ۯĂꍇ
 * \retval false \a port ̒Pʕ \a id ɑ΂ۯ֎~Ăꍇ
 */
static inline bool sysclk_module_is_enabled(enum sysclk_port_id port,
		uint8_t id)
{
	uint8_t mask = *((uint8_t *)&PR.PRGEN + port);
	return (mask & id) == 0;
}

#if XMEGA_AU || XMEGA_B || XMEGA_C || defined(__DOXYGEN__)
# if defined(CONFIG_USBCLK_SOURCE) || defined(__DOXYGEN__)
#  if (CONFIG_USBCLK_SOURCE == USBCLK_SRC_RCOSC)
#   define USBCLK_STARTUP_TIMEOUT         1
#  elif (CONFIG_USBCLK_SOURCE == USBCLK_SRC_PLL)
#   if (CONFIG_PLL0_SOURCE == PLL_SRC_XOSC)
#    define USBCLK_STARTUP_TIMEOUT        XOSC_STARTUP_TIMEOUT
#   elif (CONFIG_PLL0_SOURCE == PLL_SRC_RC32MHZ)
#    define USBCLK_STARTUP_TIMEOUT        1
#   elif (CONFIG_PLL0_SOURCE == PLL_SRC_RC2MHZ)
#    define USBCLK_STARTUP_TIMEOUT        1
#   else
#    error Unknow value for CONFIG_PLL0_SOURCE, see conf_clock.h.
#   endif
#  endif
# else /* CONFIG_USBCLK_SOURCE not defined */
#  define CONFIG_USBCLK_SOURCE USBCLK_SRC_RCOSC
#  define USBCLK_STARTUP_TIMEOUT         1
# endif /* CONFIG_USBCLK_SOURCE */
void sysclk_enable_usb(uint8_t frequency);
void sysclk_disable_usb(void);
#endif /* XMEGA_AU || XMEGA_B || XMEGA_C */
//@}

//! \name  ۯƑOǔ`Ԑݒ
//@{

/**
 * \brief  ۯOu`Ԑݒ
 *
 * ̊֐ͼ ۯOu`ԐݒҰɍ悤ɕύX܂B
 *
 * \note ̊֐ɑ΂Ұ޲LłB
 *
 * \param  psadiv  OuAݒ( \c SYSCLK_PSADIV_* `1)BclkPER4
 *				   g߂܂B
 * \param  psbcdiv OuBC̐ݒ( \c SYSCLK_PSBCDIV_* `1)B
 *				   clkPER2AclkPERAclkCPU̎g߂܂B
 */
static inline void sysclk_set_prescalers(uint8_t psadiv, uint8_t psbcdiv)
{
	ccp_write_io((uint8_t *)&CLK.PSCTRL, psadiv | psbcdiv);
}

/**
 * \brief 弽 ۯύX
 *
 * \param  src V ۯB <em> ۯ</em> ̒萔1łȂ
 *             ΂Ȃ܂B
 */
static inline void sysclk_set_source(uint8_t src)
{
	ccp_write_io((uint8_t *)&CLK.CTRL, src);
}

/**
 * \brief  ۯ`Ԑݒ{
 *
 * ̊֐݂̼͌ ۯƑOu`Ԑݒ{AXȂǂȕύX
 * h܂B
 */
static inline void sysclk_lock(void)
{
	ccp_write_io((uint8_t *)&CLK.LOCK, CLK_LOCK_bm);
}

//@}

/**
 * \name RTCۯ
 * @{
 */

/**
 * \brief w肳ꂽۯRTCۯ
 *
 * \param  id RTCۯʎqBSYSCLK_RTCSRC_ULPASYSCLK_RTCSRC_RCOSCA
 *			  SYSCLK_RTCSRC_TOSCASYSCLK_RTCSRC_RCOSC32ASYSCLK_RTCSRC_TOSC32A
 *            ܂SYSCLK_RTCSRC_EXTCLKIłB
 */
static inline void sysclk_rtcsrc_enable(uint8_t id)
{
	Assert((id & ~CLK_RTCSRC_gm) == 0);

	switch (id) {
	case SYSCLK_RTCSRC_RCOSC:
#if !XMEGA_A && !XMEGA_D
	case SYSCLK_RTCSRC_RCOSC32:
#endif
		osc_enable(OSC_ID_RC32KHZ);
		osc_wait_ready(OSC_ID_RC32KHZ);
		break;
	case SYSCLK_RTCSRC_TOSC:
	case SYSCLK_RTCSRC_TOSC32:
#if !XMEGA_A && !XMEGA_D
	case SYSCLK_RTCSRC_EXTCLK:
#endif
		osc_enable(OSC_ID_XOSC);
		osc_wait_ready(OSC_ID_XOSC);
		break;
	}

	CLK.RTCCTRL = id | CLK_RTCEN_bm;
}

/**
 * \brief RTCۯ֎~
 */
static inline void sysclk_rtcsrc_disable(void)
{
	CLK.RTCCTRL = 0;
}

/** @} */

//! \name  ۯ
//@{

extern void sysclk_init(void);

//@}

#endif /* !__ASSEMBLY__ */

//! @}

#ifdef __cplusplus
}
#endif

#endif /* XMEGA_SYSCLK_H_INCLUDED */
