/**
 * \file
 *
 * \brief ʓIɎgpݸٰށA^Aϸ
 *
 * 쌠 (c) 2010-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef UTILS_COMPILER_H
#define UTILS_COMPILER_H

/**
 * \defgroup group_xmega_utils XMEGA߲ ײ
 *
 * 8ޯAVRp߲גۑwƺ հèè
 * ̒Pʕ͈قȂ߲׊ԂŌ݊̂麰ނ邽߂ɗlXȒۑwհè
 * è񋟂܂B
 *
 * \{
 */

#if defined(__GNUC__)
#  include <avr/io.h>
#  include <avr/builtins.h>
#elif defined(__ICCAVR__)
#  include <ioavr.h>
#  include <intrinsics.h>
#else
#  error Unsupported compiler.
#endif

#include <stdbool.h>
#include <stdint.h>
#include <stddef.h>
#include <stdlib.h>

#include <parts.h>

#ifdef __ICCAVR__
/*! \name ߲ ܰ
 *
 * GCCIAR Embedded Workbenchւ̂̷ܰނ̈ڐA
 */
//! @{
#define __asm__				asm
#define __inline__			inline
#define __volatile__
//! @}
#endif

/**
 * \def UNUSED
 * \brief gpҰ܂͒lƂ\a vL܂B
 */
#define UNUSED(v)			(void)(v)

/**
 * \def unused
 * \brief gpҰ܂͒lƂ\a vL܂B
 */
#define unused(v)			do { (void)(v); } while(0)

/**
 * \def barrier
 * \brief ؏
 */
#ifdef __GNUC__
#  define barrier()			asm volatile("" ::: "memory")
#else
#  define barrier()			asm ("")
#endif

/**
 * \brief ׂ߲\a arg׸ς𑗂
 *
 * \param  arg \e \#pragmaɌ(A񉻂Ȃ)̂Ƃ׸ώw
 */
#define COMPILER_PRAGMA(arg)	_Pragma(#arg)

/*
 * AVR{\͐Cɂ܂B
 */
#define COMPILER_PACK_RESET(alignment)
#define COMPILER_PACK_SET(alignment)

/**
 * \brief 񂳂鋫Eݒ
 */
#if (defined __GNUC__)
#define COMPILER_ALIGNED(a)		__attribute__((__aligned__(a)))
#elif (defined __ICCAVR__)
#define COMPILER_ALIGNED(a)		COMPILER_PRAGMA(data_alignment = a)
#endif

/**
 * \brief ꐮ񋫊Eݒ
 */
#if (defined __GNUC__)
#define COMPILER_WORD_ALIGNED	__attribute__((__aligned__(2)))
#elif (defined __ICCAVR__)
#define COMPILER_WORD_ALIGNED	COMPILER_PRAGMA(data_alignment = 2)
#endif

/**
 * \name dꂽ悤ȎDt֐
 *
 * dꂽ悤Ȋ֐̎Dt͊֐Ă΂鎞ɂx𐶐܂B
 *
 * g͊֐`O__DEPRECATED__قǉ邱ƂłB
 * Ⴆ:
 * __DEPRECATED__ uint8_t some_deprecated_function (void)
 * {
 *     ...
 * }
 *
 * \note GCC 3.1Ƃȍ~ɂĂxAIAR͑Sx܂B
 * @{
 */
#if ((defined __GNUC__) && (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >=1)))
#define __DEPRECATED__  __attribute__((__deprecated__))
#else
#define __DEPRECATED__
#endif
//! @}

/*! \name ʏ^
 */
//! @{
typedef unsigned char	Bool;	//!< ްْl.
#ifndef __cplusplus
#if !defined(__bool_true_false_are_defined)
typedef unsigned char	bool;	//!< ްْl.
#endif
#endif
typedef int8_t		S8 ;			//!< 8ޯĕt
typedef uint8_t		U8 ;			//!< 8ޯĕȂ
typedef int16_t		S16;			//!< 16ޯĕt
typedef uint16_t	U16;			//!< 16ޯĕȂ
typedef uint16_t	le16_t;
typedef uint16_t	be16_t;
typedef int32_t		S32;			//!< 32ޯĕt
typedef uint32_t	U32;			//!< 32ޯĕȂ
typedef uint32_t	le32_t;
typedef uint32_t	be32_t;
typedef int64_t		S64;			//!< 64ޯĕt
typedef uint64_t	U64;			//!< 64ޯĕȂ
typedef float		F32;			//!< 32ޯĕ_
typedef double		F64;			//!< 64ޯĕ_
typedef uint16_t	iram_size_t;
//! @}


/*! \name Ԍ^
 */
//! @{
typedef Bool		Status_bool_t;	//!< ްْl
typedef U8			Status_t;		//!< 8ޯĕ
//! @}


/*! \name ʖŴ̌^
 */
//! @{

//! 16ޯċp
typedef union
{
  S16 s16   ;
  U16 u16   ;
  S8  s8 [2];
  U8  u8 [2];
} Union16;

//! 32ޯċp
typedef union
{
  S32 s32   ;
  U32 u32   ;
  S16 s16[2];
  U16 u16[2];
  S8  s8 [4];
  U8  u8 [4];
} Union32;

//! 64ޯċp
typedef union
{
  S64 s64   ;
  U64 u64   ;
  S32 s32[2];
  U32 u32[2];
  S16 s16[4];
  U16 u16[4];
  S8  s8 [8];
  U8  u8 [8];
} Union64;

//! 8,16,32,64ޯĕȂւ̈ʒuwq̋p
typedef union
{
  S64 *s64ptr;
  U64 *u64ptr;
  S32 *s32ptr;
  U32 *u32ptr;
  S16 *s16ptr;
  U16 *u16ptr;
  S8  *s8ptr ;
  U8  *u8ptr ;
} UnionPtr;

//! 8,16,32,64ޯĕȂւ̈ʒuwq̋p
typedef union
{
  volatile S64 *s64ptr;
  volatile U64 *u64ptr;
  volatile S32 *s32ptr;
  volatile U32 *u32ptr;
  volatile S16 *s16ptr;
  volatile U16 *u16ptr;
  volatile S8  *s8ptr ;
  volatile U8  *u8ptr ;
} UnionVPtr;

//! 萔8,16,32,64ޯĕȂւ̈ʒuwq̋p
typedef union
{
  const S64 *s64ptr;
  const U64 *u64ptr;
  const S32 *s32ptr;
  const U32 *u32ptr;
  const S16 *s16ptr;
  const U16 *u16ptr;
  const S8  *s8ptr ;
  const U8  *u8ptr ;
} UnionCPtr;

//! 萔8,16,32,64ޯĕȂւ̈ʒuwq̋p
typedef union
{
  const volatile S64 *s64ptr;
  const volatile U64 *u64ptr;
  const volatile S32 *s32ptr;
  const volatile U32 *u32ptr;
  const volatile S16 *s16ptr;
  const volatile U16 *u16ptr;
  const volatile S8  *s8ptr ;
  const volatile U8  *u8ptr ;
} UnionCVPtr;

//! 8,16,32,64ޯĕȂւ̈ʒuwq̍\
typedef struct
{
  S64 *s64ptr;
  U64 *u64ptr;
  S32 *s32ptr;
  U32 *u32ptr;
  S16 *s16ptr;
  U16 *u16ptr;
  S8  *s8ptr ;
  U8  *u8ptr ;
} StructPtr;

//! 8,16,32,64ޯĕȂւ̈ʒuwq̍\
typedef struct
{
  volatile S64 *s64ptr;
  volatile U64 *u64ptr;
  volatile S32 *s32ptr;
  volatile U32 *u32ptr;
  volatile S16 *s16ptr;
  volatile U16 *u16ptr;
  volatile S8  *s8ptr ;
  volatile U8  *u8ptr ;
} StructVPtr;

//! 萔8,16,32,64ޯĕȂւ̈ʒuwq̍\
typedef struct
{
  const S64 *s64ptr;
  const U64 *u64ptr;
  const S32 *s32ptr;
  const U32 *u32ptr;
  const S16 *s16ptr;
  const U16 *u16ptr;
  const S8  *s8ptr ;
  const U8  *u8ptr ;
} StructCPtr;

//! 萔8,16,32,64ޯĕȂւ̈ʒuwq̍\
typedef struct
{
  const volatile S64 *s64ptr;
  const volatile U64 *u64ptr;
  const volatile S32 *s32ptr;
  const volatile U32 *u32ptr;
  const volatile S16 *s16ptr;
  const volatile U16 *u16ptr;
  const volatile S8  *s8ptr ;
  const volatile U8  *u8ptr ;
} StructCVPtr;

//! @}


//_____ ϸ ________________________________________________________

/*! \name ʏ̒萔
 */
//! @{
#define DISABLE		0
#define ENABLE		1
#ifndef __cplusplus
#if !defined(__bool_true_false_are_defined)
#define false		0
#define true		1
#endif
#endif
#define PASS		0
#define FAIL		1
#define LOW			0
#define HIGH		1
//! @}


//! \name َ߲Ԉُ폈
//@{

/**
 * \internal
 * \def ERROR_FUNC(name, msg)
 * \brief ֐ĂяoȂꍇَ߲s
 *
 * ׂ߲\a name֐ɑ΂SĂ̌ĂяoœKł̏ɎsꍇB
 * قIĎgp҂\a msg\܂B
 *
 * \note SĂׂ̺߲xł͂ȂÂɂ͍őPẅ͎Ӗ
 *       łBXAݶُ킪邩ꂸAœK֎~ƁA
 *       ̋@\͊Sɋ֎~܂B
 */
#ifndef ERROR_FUNC
# define ERROR_FUNC(name, msg)                      \
	extern int name(void)
#endif

//@}

//! \name ֐Ăяo
//@{

//! spُ֐
ERROR_FUNC(compiler_demux_bad_size, "Invalid parameter size");

/**
 * \internal
 * \brief ް^̑傫ɊÂ֐Ăяo
 *
 * ް^̑傫Ɉˑ8,16,32̐ڔ֐ɑ΂֐Ăяo]
 * ܂BꂩҰ֐ɓnƂł܂B
 *
 * g:
 * \code
 * void foo8(uint8_t a, void *b);
 * void foo16(uint16_t a, void *b);
 * void foo32(uint32_t a, void *b);
 *
 * #define foo(x, y)    compiler_demux_size(sizeof(x), foo, x, y)
 * \endcode
 *
 * \param  size ް^̑傫
 * \param  func ֐
 * \param  ...  ֐֓nҰ̈ꗗ
 */
#define compiler_demux_size(size, func, ...)        \
	(((size) == 1) ? func##8(__VA_ARGS__) :     \
	 ((size) == 2) ? func##16(__VA_ARGS__) :    \
	 ((size) == 4) ? func##32(__VA_ARGS__) :    \
	 compiler_demux_bad_size())

//@}

/**
 * \def __always_inline
 * \brief ֐͏ɲײׂ݉
 *
 * ̒L͔IwKײ݉𖳎ĂǂȂɂꂪ傫ȂƍlĂ
 * ֐ײ݂ɂ邱Ƃׂ߲Ɏw܂B
 */
#if (defined __GNUC__)
	#define __always_inline		inline __attribute__((__always_inline__))
#elif (defined __ICCAVR__)
	#define __always_inline		_Pragma("inline=forced")
#endif

//! \name œK
//@{

/**
 * \def __always_optimize
 * \brief ֐͏ɍœKׂ
 *
 * ̒L͑S̓IȍœKݒ𖳎ďɍ̍œKŊ֐߲ق
 * Ƃׂ߲Ɏw܂B
 */
#if (defined __GNUC__)
	#define __always_optimize	__attribute__((optimize(3)))
#elif (defined __ICCAVR__)
	#define __always_optimize	_Pragma("optimize=high")
#endif

/**
 * \def likely(exp)
 * \brief \a exp͋炭^łB
 */
#ifndef likely
# define likely(exp)	(exp)
#endif

/**
 * \def unlikely(exp)
 * \brief \a exp͋炭^ł͂܂B
 */
#ifndef unlikely
# define unlikely(exp)	(exp)
#endif

/**
 * \def is_constant(exp)
 * \brief 萔lƕ]邩
 *
 * \param  exp ꂩ̎
 *
 * \return \a exp萔ȂtrueAȂfalse
 */
#ifdef __GNUC__
# define is_constant(exp)		__builtin_constant_p(exp)
#else
# define is_constant(exp)		(0)
#endif

//! @}

/*! \name ޯė̈̈
 */
#include "bit_handling/clz_ctz.h"
//! @{

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽlޯĂǂݍ
 *
 * \param  value ޯĂǂޒl
 * \param  mask  ǂޯĂwޯĎՕ
 *
 * \return ޯēǂݍ
 */
#define Rd_bits( value, mask)	((value)&(mask))

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽCӒlޯď
 *
 * \param  lvalue ޯĂCӒl
 * \param  mask   ޯĂwޯĎՕ
 * \param  bits   ޯ
 *
 * \return ꂽޯĂʒl
 */
#define Wr_bits(lvalue, mask, bits)	((lvalue) = ((lvalue) & ~(mask)) |\
												((bits  ) &  (mask)))

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽlޯĂ
 *
 * \param  value ޯĂ邽߂̒l
 * \param  mask  ޯĂwޯĎՕ
 *
 * \return ޯĂ̍Œ1ݒȂ\c 1AȂ\c 0
 */
#define Tst_bits( value, mask)	(Rd_bits(value, mask) != 0)

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽCӒlޯĂ
 *
 * \param  lvalue ޯĂCӒl
 * \param  mask   ޯĂwޯĎՕ
 *
 * \return ޯĂʒl
 */
#define Clr_bits(lvalue, mask)	((lvalue) &= ~(mask))

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽCӒlޯĂݒ
 *
 * \param  lvalue ޯĂݒ肷CӒl
 * \param  mask   ݒ肷ޯĂwޯĎՕ
 *
 * \return ݒ肵ޯĂʒl
 */
#define Set_bits(lvalue, mask)	((lvalue) |=  (mask))

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽCӒlޯĂ𔽓]
 *
 * \param  lvalue ޯĂ𔽓]CӒl
 * \param  mask   ]ޯĂwޯĎՕ
 *
 * \return ]ޯĂʒl
 */
#define Tgl_bits(lvalue, mask)	((lvalue) ^=  (mask))

/*! \brief ^ꂽޯĎՕɂĎw肳ꂽlޯė̈ǂݍ
 *
 * \param  value ޯė̈ǂޒl
 * \param  mask  ǂޯė̈wޯĎՕ
 *
 * \return ǂޯė̈
 */
#define Rd_bitfield( value,mask)	(Rd_bits( value, (uint32_t)mask) >> ctz(mask))

/*! \brief ^炽ޯĎՕɂĎw肳ꂽCӒlޯė̈揑
 *
 * \param  lvalue    ޯė̈CӒl
 * \param  mask      ޯė̈wޯĎՕ
 * \param  bitfield  ޯė̈
 *
 * \return ꂽޯė̈ʒl
 */
#define Wr_bitfield(lvalue, mask, bitfield)	(Wr_bits(lvalue, mask, (uint32_t)(bitfield) << ctz(mask)))

//! @}

/*! \brief ϸۂ͒vIُ팟Ɏgp܂B
 *
 * ϸۂ͎肩܂BȂAvIُ킪oꉞp~
 * BTEST_SUITE_DEFINE_ASSERT_MACRO`ꍇǍ̍XȂ錟
 * ̎s߁Aϸۂ̒Pʌłgp܂B
 *
 * \param  expr 0ƕ]l鎮
 */
#if defined(_ASSERT_ENABLE_)
#  if defined(TEST_SUITE_DEFINE_ASSERT_MACRO)
	// Assert()unit_test/suite.hŒ`܂B
#    include "unit_test/suite.h"
#  else
#    define Assert(expr) \
	{\
		if (!(expr)) while (true);\
	}
#  endif
#else
#  define Assert(expr) ((void) 0)
#endif

/*! \name ޯĔ]
 */
//! @{

/*! \brief \a u8ޯĔ]
 *
 * \param  u8 ޯĂ𔽓]U8
 *
 * \return ]ޯĂ\a u8̌ʒl
 */
#define bit_reverse8(u8)	((U8)(bit_reverse32((U8)(u8)) >> 24))

/*! \brief \a u16ޯĔ]
 *
 * \param  u16 ޯĂ𔽓]U16
 *
 * \return ]ޯĂ\a u16̌ʒl
 */
#define bit_reverse16(u16)	((U16)(bit_reverse32((U16)(u16)) >> 16))

/*! \brief \a u32ޯĔ]
 *
 * \param  u32 ޯĂ𔽓]U32
 *
 * \return ]ޯĂ\a u32̌ʒl
 */
#if (defined __GNUC__)
  #define bit_reverse32(u32) \
  (\
    {\
      unsigned int __value = (U32)(u32);\
      __asm__ ("brev\t%0" : "+r" (__value) :  : "cc");\
      (U32)__value;\
    }\
  )
#elif (defined __ICCAVR__)
  #define bit_reverse32(u32)	((U32)__bit_reverse((U32)(u32)))
#endif

/*! \brief \a u64ޯĔ]
 *
 * \param  u64 ޯĂ𔽓]U64
 *
 * \return ]ޯĂ\a u64̌ʒl
 */
#define bit_reverse64(u64)	((U64)(((U64)bit_reverse32((U64)(u64) >> 32)) |\
								   ((U64)bit_reverse32((U64)(u64)) << 32)))

//! @}

//! \name ΐ֐
//! @{

/**
 * \internal
 * `֐BȒ萔lƋilog2()Ă΂ꂽꍇݸs
 */
int_fast8_t ilog2_undefined(void);

/**
 * \brief ł߂ɐ؂艺ꂽ2ƂΐvZ܂B
 *
 * \param  x 32ޯĒl
 * \return \a x2ƂΐA\a x0̏ꍇ-1
 */
static inline int_fast8_t ilog2(uint32_t x)
{
	if (is_constant(x))
		return ((x) & (1ULL << 31) ? 31 :
			(x) & (1ULL << 30) ? 30 :
			(x) & (1ULL << 29) ? 29 :
			(x) & (1ULL << 28) ? 28 :
			(x) & (1ULL << 27) ? 27 :
			(x) & (1ULL << 26) ? 26 :
			(x) & (1ULL << 25) ? 25 :
			(x) & (1ULL << 24) ? 24 :
			(x) & (1ULL << 23) ? 23 :
			(x) & (1ULL << 22) ? 22 :
			(x) & (1ULL << 21) ? 21 :
			(x) & (1ULL << 20) ? 20 :
			(x) & (1ULL << 19) ? 19 :
			(x) & (1ULL << 18) ? 18 :
			(x) & (1ULL << 17) ? 17 :
			(x) & (1ULL << 16) ? 16 :
			(x) & (1ULL << 15) ? 15 :
			(x) & (1ULL << 14) ? 14 :
			(x) & (1ULL << 13) ? 13 :
			(x) & (1ULL << 12) ? 12 :
			(x) & (1ULL << 11) ? 11 :
			(x) & (1ULL << 10) ? 10 :
			(x) & (1ULL <<  9) ?  9 :
			(x) & (1ULL <<  8) ?  8 :
			(x) & (1ULL <<  7) ?  7 :
			(x) & (1ULL <<  6) ?  6 :
			(x) & (1ULL <<  5) ?  5 :
			(x) & (1ULL <<  4) ?  4 :
			(x) & (1ULL <<  3) ?  3 :
			(x) & (1ULL <<  2) ?  2 :
			(x) & (1ULL <<  1) ?  1 :
			(x) & (1ULL <<  0) ?  0 :
			ilog2_undefined());

	return 31 - clz(x);
}

//! @}

/*! \name 
 */
//! @{

/*! \brief \a n̋E\a val̐̐
 *
 * \param  val ͒l
 * \param  n   E
 *
 * \return \a val̐\a n̋EŐ񂳂Ăꍇ\c 1AȂ\c 0
 */
#define Test_align(val, n     ) (!Tst_bits( val, (n) - 1     )   )

/*! \brief \a n̋Eɂ\a val̐̐擾
 *
 * \param  val ͒l
 * \param  n   E
 *
 * \return \a n̋Eɂ\a val̐̐
 */
#define Get_align( val, n     ) (  Rd_bits( val, (n) - 1     )   )

/*! \brief \a n̋Eɂ\a lval̍Ӓl̐̐\a algɐݒ
 *
 * \param  lval o͍Ӓl
 * \param  n     E
 * \param  alg   
 *
 * \return \a n̋Eɂ\a algɐݒ肳ꂽ̐񂩂̌ʂ̐V\a lval̒l
 */
#define Set_align(lval, n, alg) (  Wr_bits(lval, (n) - 1, alg)   )

/*! \brief \a n̋E؂グ\a val̐𐮗
 *
 * \param  val ͒l
 * \param  n   E
 *
 * \return \a n̋E؂グŐ񂵂\a val̐̌ʒl
 */
#define Align_up(  val, n     ) (((val) + ((n) - 1)) & ~((n) - 1))

/*! \brief \a n̋E؂艺\a val̐𐮗
 *
 * \param  val ͒l
 * \param  n   E
 *
 * \return \a n̋E؂艺Ő񂵂\a val̐̌ʒl
 */
#define Align_down(val, n     ) ( (val)              & ~((n) - 1))

//! @}


/*! \name Zp
 *
 * WinAVRabsɑ΂ĂA萔ɑ΂߲׍œK
 */
//! @{

/*! \brief \a a̐Βl
 *
 * \param  a ͒l
 *
 * \return \a a̐Βl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK
 */
#define Abs(a)		(((a) <  0 ) ? -(a) : (a))
#ifndef abs
#define abs(a)		Abs(a)
#endif

/*! \brief \a a\a b̍ŏl
 *
 * \param  a ͒l
 * \param  b ͒l
 *
 * \return \a a\a b̍ŏl
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK
 */
#define Min(a, b)	(((a) < (b)) ?  (a) : (b))
#define min(a, b)	Min(a, b)

/*! \brief \a a\a b̍ől
 *
 * \param  a ͒l
 * \param  b ͒l
 *
 * \return \a a\a b̍ől
 *
 * \note َ߲Ɋm̒lłgpꍇɂƍœK
 */
#define Max(a, b)	(((a) > (b)) ?  (a) : (b))
#define max(a, b)	Max(a, b)

//! @}


/*! \brief \a addṟڽٰ݌Ăяo
 *
 * Ăяo캰ނ𐶐܂B
 *
 * Ⴆ΁A`Long_call(0x80000000)'͂ꂪCPUǗ삩ĂяoꂽꍇAUC3
 * ĳ ؾĂ𐶐܂B
 *
 * \param  addr Ăٰ݂̱ڽ
 *
 * \note ̓ʂȏꍇŒެߑ캰ނƂĎgp邩܂B
 */
#define Long_call(addr)					((*(void (*)(void))(addr))())

/*! \name  ڼ޽ 
 */
//! @{

/*! \brief  ڼ޽\a sysreg̒l擾
 *
 * \param  sysreg l𓾂鼽 ڼ޽̱ڽ
 *
 * \return  ڼ޽\a sysreg̒l
 */
#if (defined __GNUC__)
  #define Get_system_register(sysreg)	__builtin_mfsr(sysreg)
#elif (defined __ICCAVR__)
  #define Get_system_register(sysreg)	__get_system_register(sysreg)
#endif

/*! \brief  ڼ޽\a sysreg̒l\a valueɐݒ
 *
 * \param  sysreg lݒ肷鼽 ڼ޽̱ڽ
 * \param  value   ڼ޽\a sysregɐݒ肷l
 */
#if (defined __GNUC__)
  #define Set_system_register(sysreg, value)	__builtin_mtsr(sysreg, value)
#elif (defined __ICCAVR__)
  #define Set_system_register(sysreg, value)	__set_system_register(sysreg, value)
#endif

//! @}

/*! \name ޯ ڼ޽ 
 */
//! @{

/*! \brief ޯ ڼ޽\a dbgreg̒l擾
 *
 * \param  dbgreg l𓾂ޯ ڼ޽̱ڽ
 *
 * \return ޯ ڼ޽\a dbgreg̒l
 */
#if (defined __GNUC__)
  #define Get_debug_register(dbgreg)	__builtin_mfdr(dbgreg)
#elif (defined __ICCAVR__)
  #define Get_debug_register(dbgreg)	__get_debug_register(dbgreg)
#endif

/*! \brief ޯ ڼ޽\a dbgreg̒l\a valueɐݒ
 *
 * \param  dbgreg lݒ肷ޯ ڼ޽̱ڽ
 * \param  value  ޯ ڼ޽\a dbgreg̒l
 */
#if (defined __GNUC__)
  #define Set_debug_register(dbgreg, value)		__builtin_mtdr(dbgreg, value)
#elif (defined __ICCAVR__)
  #define Set_debug_register(dbgreg, value)		__set_debug_register(dbgreg, value)
#endif

//! @}


/*! \name MCUި݂̈
 * xmegaMCU ި݂łB
 */
//! @{
#define  MSB(u16)		(((uint8_t* )&u16)[1])
#define  LSB(u16)		(((uint8_t* )&u16)[0])

#define  MSW(u32)		(((uint16_t*)&u32)[1])
#define  LSW(u32)		(((uint16_t*)&u32)[0])
#define  MSB0W(u32)		(((uint8_t*)&(u32))[3])	//!< \a u32̑1̍ŏ޲
#define  MSB1W(u32)		(((uint8_t*)&(u32))[2])	//!< \a u32̑2̍ŏ޲
#define  MSB2W(u32)		(((uint8_t*)&(u32))[1])	//!< \a u32̑3̍ŏ޲
#define  MSB3W(u32)		(((uint8_t*)&(u32))[0])	//!< \a u32̑4̍ŏ޲
#define  LSB3W(u32)		MSB0W(u32)				//!< \a u32̑4̍ŉ޲
#define  LSB2W(u32)		MSB1W(u32)				//!< \a u32̑3̍ŉ޲
#define  LSB1W(u32)		MSB2W(u32)				//!< \a u32̑2̍ŉ޲
#define  LSB0W(u32)		MSB3W(u32)				//!< \a u32̑1̍ŉ޲

#define  MSB0(u32)		(((uint8_t*)&u32)[3])
#define  MSB1(u32)		(((uint8_t*)&u32)[2])
#define  MSB2(u32)		(((uint8_t*)&u32)[1])
#define  MSB3(u32)		(((uint8_t*)&u32)[0])
#define  LSB0(u32)		MSB3(u32)
#define  LSB1(u32)		MSB2(u32)
#define  LSB2(u32)		MSB1(u32)
#define  LSB3(u32)		MSB0(u32)

#define  LE16(x)		(x)
#define  le16_to_cpu(x)	(x)
#define  cpu_to_le16(x)	(x)
#define  LE16_TO_CPU(x)	(x)
#define  CPU_TO_LE16(x)	(x)

#define  BE16(x)		Swap16(x)
#define  be16_to_cpu(x)	swap16(x)
#define  cpu_to_be16(x)	swap16(x)
#define  BE16_TO_CPU(x)	Swap16(x)
#define  CPU_TO_BE16(x)	Swap16(x)

#define  LE32(x)		(x)
#define  le32_to_cpu(x)	(x)
#define  cpu_to_le32(x)	(x)
#define  LE32_TO_CPU(x)	(x)
#define  CPU_TO_LE32(x)	(x)

#define  BE32(x)		Swap32(x)
#define  be32_to_cpu(x)	swap32(x)
#define  cpu_to_be32(x)	swap32(x)
#define  BE32_TO_CPU(x)	Swap32(x)
#define  CPU_TO_BE32(x)	Swap32(x)

//! @}

/*! \name ިݕϊ
 *
 * clzctzɂĂƓlɓKp܂AAAVR32-GCC
 * __builtin_bswap_16__builtin_bswap_32͒萔ɓKp鎞ϸۂ̂悤ɓ
 * Âϸۂ2̑gŒ`܂B
 *   - 萔ɓKp邽߂Swap16,Swap32,Swap64(َ߲Ɋm̒l)
 *   - 萔ɓKp邽߂swap16,swap32,swap64(َ߲ɖm̒l)
 */
//! @{

/*! \brief (޲Čɂ)\a u16̴ިݐ؂ւ
 *
 * \param  u16 ި݂؂ւU16
 *
 * \return ؂ւި݂ł\a u16̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK܂B
 */
#define Swap16(u16) ((U16)(((U16)(u16) >> 8) |\
                           ((U16)(u16) << 8)))

/*! \brief (޲Čɂ)\a u32̴ިݐ؂ւ
 *
 * \param  u32 ި݂؂ւU32
 *
 * \return ؂ւި݂ł\a u32̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK܂B
 */
#define Swap32(u32) ((U32)(((U32)Swap16((U32)(u32) >> 16)) |\
                           ((U32)Swap16((U32)(u32)) << 16)))

/*! \brief (޲Čɂ)\a u64̴ިݐ؂ւ
 *
 * \param  u64 ި݂؂ւU64
 *
 * \return ؂ւި݂ł\a u64̌ʒl
 *
 * \note َ߲Ɋm̒lŎgp邾̏ꍇɂƍœK܂B
 */
#define Swap64(u64) ((U64)(((U64)Swap32((U64)(u64) >> 32)) |\
                           ((U64)Swap32((U64)(u64)) << 32)))

/*! \brief (޲Čɂ)\a u16̴ިݐ؂ւ
 *
 * \param  u16 ި݂؂ւU16
 *
 * \return ؂ւި݂ł\a u16̌ʒl
 *
 * \note َ߲ɖm̒lŎgp邾̏ꍇɂƍœK܂B
 */
#define swap16(u16) Swap16(u16)

/*! \brief (޲Čɂ)\a u32̴ިݐ؂ւ
 *
 * \param  u32 ި݂؂ւU32
 *
 * \return ؂ւި݂ł\a u32̌ʒl
 *
 * \note َ߲ɖm̒lŎgp邾̏ꍇɂƍœK܂B
 */
#define swap32(u32) Swap32(u32)

/*! \brief (޲Čɂ)\a u64̴ިݐ؂ւ
 *
 * \param  u64 ި݂؂ւU64
 *
 * \return ؂ւި݂ł\a u64̌ʒl
 *
 * \note َ߲ɖm̒lŎgp邾̏ꍇɂƍœK܂B
 */
#define swap64(u64) ((U64)(((U64)swap32((U64)(u64) >> 32)) |\
                           ((U64)swap32((U64)(u64)) << 32)))

//! @}


/*! \name ړIΏےۉ
 */
//! @{

#define _GLOBEXT_			extern		//!< OL׽wq
#define _CONST_TYPE_		const		//!< 萔^Cq
#define _MEM_TYPE_SLOW_					//!< ᑬ،^
#define _MEM_TYPE_MEDFAST_				//!< ܂܂،^
#define _MEM_TYPE_FAST_					//!< ،^

typedef U8					Byte;		//!< 8ޯĕȂ

#define memcmp_ram2ram		memcmp		//!< RAMRAM̖ړIΏۓmemcmp
#define memcmp_code2ram		memcmp		//!< RAMNVRAM̖ړIΏۓmemcmp
#define memcpy_ram2ram		memcpy		//!< RAMRAMւ̖ړIΏۓmemcpy
#define memcpy_code2ram		memcpy		//!< NVRAMRAMւ̖ړIΏۓmemcpy

//! @}

/**
 * \brief Zp\f$ \left\lceil \frac{a}{b} \right\rceil \f$vZ
 *
 * \param  a 
 * \param  b ʂ̐
 *
 * \return ł߂Ɋۂߏグꂽ(\a a / \a b)
 */
#define div_ceil(a, b)	(((a) + (b) - 1) / (b))

#include "preprocessor.h"
#include "progmem.h"
#include "interrupt.h"


#if (defined __GNUC__)
  #define SHORTENUM			__attribute__ ((packed))
#elif (defined __ICCAVR__)
  #define SHORTENUM			/**/
#endif

#if (defined __GNUC__)
  #define FUNC_PTR			void *
#elif (defined __ICCAVR__)
#if (FLASHEND > 0x1FFFF)	// 128KB傫۸ ĂɊւĕKvƂ܂B
  #define FUNC_PTR			void __farflash *
#else
  #define FUNC_PTR			void *
#endif  /* ENABLE_FAR_FLASH */
#endif


#if (defined __GNUC__)
  #define FLASH_DECLARE(x)	const x __attribute__((__progmem__))
#elif (defined __ICCAVR__)
  #define FLASH_DECLARE(x)	const __flash x
#endif

#if (defined __GNUC__)
  #define FLASH_EXTERN(x)	extern const x
#elif (defined __ICCAVR__)
  #define FLASH_EXTERN(x)	extern const __flash x
#endif


/* MAC̗vƉpׯL` */
#define CMD_ID_OCTET			(0)

/* CPUި݂ ި݂֒l̕ϊ */
#define CPU_ENDIAN_TO_LE16(x)	(x)
#define CPU_ENDIAN_TO_LE32(x)	(x)
#define CPU_ENDIAN_TO_LE64(x)	(x)

/*  ި݂CPUި݂֒l̕ϊ */
#define LE16_TO_CPU_ENDIAN(x)	(x)
#define LE32_TO_CPU_ENDIAN(x)	(x)
#define LE64_TO_CPU_ENDIAN(x)	(x)

/*  ި݂CPUި݂֒萔̕ϊ */
#define CLE16_TO_CPU_ENDIAN(x)	(x)
#define CLE32_TO_CPU_ENDIAN(x)	(x)
#define CLE64_TO_CPU_ENDIAN(x)	(x)

/* CPUި݂ ި݂֒萔̕ϊ */
#define CCPU_ENDIAN_TO_LE16(x)	(x)
#define CCPU_ENDIAN_TO_LE32(x)	(x)
#define CCPU_ENDIAN_TO_LE64(x)	(x)

#if (defined __GNUC__)
  #define ADDR_COPY_DST_SRC_16(dst, src)	memcpy((&(dst)), (&(src)), sizeof(uint16_t))
  #define ADDR_COPY_DST_SRC_64(dst, src)	memcpy((&(dst)), (&(src)), sizeof(uint64_t))

/* 2޲Ĕz16ޯĒlɕϊ */
#define convert_byte_array_to_16_bit(data) \
    (*(uint16_t *)(data))

/* 4޲Ĕz32ޯĒlɕϊ */
#define convert_byte_array_to_32_bit(data) \
    (*(uint32_t *)(data))

/* 8޲Ĕz64ޯĒlɕϊ */
#define convert_byte_array_to_64_bit(data) \
    (*(uint64_t *)(data))

/* 16ޯĒl2޲Ĕzɕϊ */
#define convert_16_bit_to_byte_array(value, data) \
    ((*(uint16_t *)(data)) = (uint16_t)(value))

/* 16ޯĒl2޲Ĕzɕϊ */
#define convert_spec_16_bit_to_byte_array(value, data) \
    ((*(uint16_t *)(data)) = (uint16_t)(value))

/* 16ޯĒlڽlɕϊ */
#define convert_16_bit_to_byte_address(value, data) \
    ((*(uint16_t *)(data)) = (uint16_t)(value))

/* 32ޯĒl4޲Ĕzɕϊ */
#define convert_32_bit_to_byte_array(value, data) \
    ((*(uint32_t *)(data)) = (uint32_t)(value))

/* 64ޯĒl8޲Ĕzɕϊ */
/* memcpy͂ƏȂ؎gpʂKv܂B */
#define convert_64_bit_to_byte_array(value, data) \
    memcpy((data), (&(value)), sizeof(uint64_t))

#elif (defined __ICCAVR__)
  #define ADDR_COPY_DST_SRC_16(dst, src)	((dst) = (src))
  #define ADDR_COPY_DST_SRC_64(dst, src)	((dst) = (src))

/* 2޲Ĕz16ޯĒlɕϊ */
#define convert_byte_array_to_16_bit(data) \
    (*(uint16_t *)(data))

/* 4޲Ĕz32ޯĒlɕϊ */
#define convert_byte_array_to_32_bit(data) \
    (*(uint32_t *)(data))

/* 8޲Ĕz64ޯĒlɕϊ */
#define convert_byte_array_to_64_bit(data) \
    (*(uint64_t *)(data))

/* 16ޯĒl2޲Ĕzɕϊ */
#define convert_16_bit_to_byte_array(value, data) \
    ((*(uint16_t *)(data)) = (uint16_t)(value))

/* 16ޯĒl2޲Ĕzɕϊ */
#define convert_spec_16_bit_to_byte_array(value, data) \
    ((*(uint16_t *)(data)) = (uint16_t)(value))

/* 16ޯĒlڽlɕϊ */
#define convert_16_bit_to_byte_address(value, data) \
    ((*(uint16_t *)(data)) = (uint16_t)(value))

/* 32ޯĒl4޲Ĕzɕϊ */
#define convert_32_bit_to_byte_array(value, data) \
    ((*(uint32_t *)(data)) = (uint32_t)(value))

/* 64ޯĒl8޲Ĕzɕϊ */
#define convert_64_bit_to_byte_array(value, data) \
    ((*(uint64_t *)(data)) = (uint64_t)(value))
#endif

#define MEMCPY_ENDIAN memcpy
#define PGM_READ_BLOCK(dst, src, len) memcpy_P((dst), (src), (len))

#if (defined __GNUC__)
  #define PGM_READ_BYTE(x)	pgm_read_byte(x)
  #define PGM_READ_WORD(x)	pgm_read_word(x)
#elif (defined __ICCAVR__)
  #define PGM_READ_BYTE(x)	*(x)
  #define PGM_READ_WORD(x)	*(x)
#endif


#if (defined __GNUC__)
  #define nop() do { __asm__ __volatile__ ("nop"); } while (0)
#elif (defined __ICCAVR__)
  #define nop() __no_operation()
#endif


/**
 * \}
 */

#endif  // UTILS_COMPILER_H
